// Ion.cpp : AvP[VpNX̋@\`s܂B
//

#include "stdafx.h"
#include "Ion.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "IonDoc.h"
#include "IonView.h"
#include "mInitialize.h"
#include "kSizeView.h"
#include "kMessage.h"
#include "kInitialize.h"

#include <iomanip>
#include <cstdlib>
#include <direct.h>
#include <ctime>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CIonApp

BEGIN_MESSAGE_MAP(CIonApp, CWinApp)
	//{{AFX_MSG_MAP(CIonApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_MENUITEM_CONTROL, OnMenuitemControl)
	ON_COMMAND(ID_MENUITEM_WINMANE_SEED, OnMenuitemWinmaneSeed)
	ON_UPDATE_COMMAND_UI(ID_MENUITEM_WINMANE_SEED, OnUpdateMenuitemWinmaneSeed)
	ON_COMMAND(ID_MENUITEM_WINMANE_GENE, OnMenuitemWinmaneGene)
	ON_UPDATE_COMMAND_UI(ID_MENUITEM_WINMANE_GENE, OnUpdateMenuitemWinmaneGene)
	ON_COMMAND(ID_MENUITEM_WINMANE_DAUGHTER, OnMenuitemWinmaneDaughter)
	ON_UPDATE_COMMAND_UI(ID_MENUITEM_WINMANE_DAUGHTER, OnUpdateMenuitemWinmaneDaughter)
	ON_COMMAND(ID_MENUITEM_WINMANE_MOTHER, OnMenuitemWinmaneMother)
	ON_UPDATE_COMMAND_UI(ID_MENUITEM_WINMANE_MOTHER, OnUpdateMenuitemWinmaneMother)
	ON_COMMAND(ID_MENUITEM_WINMANE_SIZE, OnMenuitemWinmaneSize)
	ON_UPDATE_COMMAND_UI(ID_MENUITEM_WINMANE_SIZE, OnUpdateMenuitemWinmaneSize)
	ON_COMMAND(ID_MENUITEM_SAVE_BIRD_VIEW, OnMenuitemSaveBirdView)
	//}}AFX_MSG_MAP
	// W̃t@C{hLg R}h
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIonApp NX̍\z

CIonApp::CIonApp()
{
	// TODO: ̈ʒuɍ\zpR[hǉĂB
	//  InitInstance ̏dvȏׂċLqĂB
	b_isFileAccess = false;
}

/////////////////////////////////////////////////////////////////////////////
// B CIonApp IuWFNg

CIonApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CIonApp NX̏

BOOL CIonApp::InitInstance()
{
	{	// BLOCK: doc ev[g̓o^
		// hLg ev[go^܂BhLg ev[ǵA
		// hLgAt[ EBhEAr[̊Ԃ̊֘Ats܂B
		// ̃tH[𑼂̃hLgt[ EBhEɃA^b`ɂ
		// ȉ̃RXgN^̃hLg܂̓t[ NXύXĂ
		pSizeTemplate = new CMultiDocTemplate(
			IDR_IONTYPE,
			RUNTIME_CLASS(CIonDoc),		// hLg NX
			RUNTIME_CLASS(CMDIChildWnd),		// t[ NX
			RUNTIME_CLASS(kSizeView));		// r[ NX
		AddDocTemplate(pSizeTemplate);

		pMotherTemplate = new CMultiDocTemplate(
			IDR_IONTYPE,
			RUNTIME_CLASS(CIonDoc),		// hLg NX
			RUNTIME_CLASS(CChildFrame),		// t[ NX
			RUNTIME_CLASS(kMotherView));		// r[ NX
		AddDocTemplate(pMotherTemplate);

		pDaughterTemplate = new CMultiDocTemplate(
			IDR_IONTYPE,
			RUNTIME_CLASS(CIonDoc),		// hLg NX
			RUNTIME_CLASS(CChildFrame),		// t[ NX
			RUNTIME_CLASS(kDaughterView));		// r[ NX
		AddDocTemplate(pDaughterTemplate);

		pGeneTemplate = new CMultiDocTemplate(
			IDR_IONTYPE,
			RUNTIME_CLASS(CIonDoc),		// hLg NX
			RUNTIME_CLASS(CChildFrame),		// t[ NX
			RUNTIME_CLASS(kGeneView));		// r[ NX
		AddDocTemplate(pGeneTemplate);

		pSeedTemplate = new CMultiDocTemplate(
			IDR_IONTYPE,
			RUNTIME_CLASS(CIonDoc),
			RUNTIME_CLASS(CChildFrame), // JX^ MDI qt[
			RUNTIME_CLASS(kSeedView));
		AddDocTemplate(pSeedTemplate);

		pSeedView = NULL;
		pGeneView = NULL;
		pDaughterView = NULL;
		pMotherView = NULL;
		pSizeView = NULL;
	}

	AfxEnableControlContainer();

	// WIȏ
	// ̋@\gpAst@C̃TCY
	// Έȉ̓̏[`̒sKvȂ
	// 폜ĂB

#ifdef _AFXDLL
	Enable3dControls();		// L DLL ̒ MFC gpꍇɂ͂ĂяoĂB
#else
	Enable3dControlsStatic();	// MFC ƐÓIɃNĂꍇɂ͂ĂяoĂB
#endif

	// ݒ肪ۑ鉺̃WXg L[ύX܂B
	// TODO: ̕AЖ܂͏ȂǓK؂Ȃ̂
	// ύXĂB
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings();  // W INI t@C̃IvV[ނ܂ (MRU ܂)

	// AvP[Vp̃hLg ev[go^܂BhLg ev[g
	//  ̓hLgAt[ EBhEƃr[邽߂ɋ@\܂B

/*	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_IONTYPE,
		RUNTIME_CLASS(CIonDoc),
		RUNTIME_CLASS(CChildFrame), // JX^ MDI qt[
		RUNTIME_CLASS(CIonView));
	AddDocTemplate(pDocTemplate);
*/

	// C MDI t[ EBhE쐬
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_IONTYPE))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// DDEAfile open ȂǕW̃VF R}h̃R}hC͂܂B
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	//AvP[VNɐVKhLgJȂ悤ɂ
	cmdInfo.m_nShellCommand = CCommandLineInfo::FileNothing;


	// R}hCŃfBXpb` R}hw肵܂B
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// C EBhEꂽ̂ŁA\ƍXVs܂B
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	control = NULL;
	control = new kControl;

	Mayu = new mMother;

	waitFile();
	fileLock();

	//Ƀt@C̓ǂݍ݂
	//AfxMessageBox("TEST");
	if(AfxMessageBox("t@Cǂݍ݂܂B\n"
		"Ȉꍇ́Ãt@C_CAOŃLZIĂB\n"
		"ŁffIƂ͏I܂B",MB_YESNO)== IDNO){
		fileUnlock();
		forceExit();
	}

	CFileDialog fileDialog(true,"ion","*.ion",
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT ,
		"Ion Files (*.ion)|*.ion||",pMainFrame);
	char lpBuffer[_MAX_PATH];
	GetCurrentDirectory(_MAX_PATH,lpBuffer);
	executePath = CString(lpBuffer)+'\\';
	fileDialog.m_ofn.lpstrInitialDir = executePath.operator LPCTSTR();

	if(fileDialog.DoModal()==IDOK){
		CString fileName = fileDialog.GetPathName();
		pathName = fileName.Left(fileName.ReverseFind('\\'))+'\\';
		kMessage m;
		m.makeDialog();
		m.setText("Ion :: t@Cǂݍݒ");
		Mayu->selfLoad(pathName);
		m.destroyDialog();
	}else{
		if(AfxMessageBox("Ȃ '͂' , IȂ '' IĂ",MB_YESNO)== IDNO){
			fileUnlock();
			forceExit();
		}
		kInitialize *kinit = new kInitialize;
		kinit->DoModal();
		if(kinit->isExit()){
			delete kinit;
			fileUnlock();
			forceExit();
		}
		CString geneInit = kinit->m_edit_gene;
		CString parameterInit = kinit->m_edit_parameter;
		delete kinit;
		
		Mayu->initialize(geneInit,parameterInit);
		CString message = CString("܂BZ[utH_ ")
			+ pathName+"łB";
		AfxMessageBox(message);
		//-----------------------------
	}
	fileUnlock();
	openInitialWindows();

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
		// bZ[W nh͂܂B
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh͂܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// _CAOs邽߂̃AvP[V R}h
void CIonApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CIonApp bZ[W nh

bool CIonApp::bOpenSeed = false;//QdI[vh

bool CIonApp::getOpenWindowSeed()
{
	return bOpenSeed;
}

void CIonApp::openWindowSeed()
{
	//SeedEBhEJ
	if(bOpenSeed){
		return;
	}
	pSeedFrame = new CChildFrame;
	pSeedDoc = new CIonDoc;
	pSeedDoc->SetTitle("Seed View");

	CCreateContext context;
	context.m_pCurrentDoc = pSeedDoc;
	context.m_pNewViewClass = RUNTIME_CLASS(kSeedView);
	context.m_pNewDocTemplate = pSeedTemplate;
	context.m_pLastView = (((CMainFrame*) m_pMainWnd)->GetActiveWindow()
		? ((CMainFrame*)m_pMainWnd)->GetActiveFrame()->GetActiveView()
		: NULL);
	context.m_pCurrentFrame = ((CMainFrame*)m_pMainWnd)->GetActiveFrame();

//	if(!pSeedFrame->LoadFrame(IDR_KSEEDVIEW_TMPL,
	if(!pSeedFrame->LoadFrame(IDR_IONTYPE,
		WS_OVERLAPPEDWINDOW | FWS_PREFIXTITLE | FWS_ADDTOTITLE,
		m_pMainWnd,&context)){
			return;
	}
	pSeedFrame->InitialUpdateFrame(pSeedDoc,true);

	bOpenSeed = true;

}

void CIonApp::closeWindowSeed()
{
	if(!bOpenSeed){
		return;
	}
	bOpenSeed = false;
	pSeedDoc = NULL;
	pSeedFrame = NULL;
}

bool CIonApp::bOpenGene = false;//QdI[vh

bool CIonApp::getOpenWindowGene()
{
	return bOpenGene;
}

void CIonApp::openWindowGene()
{
	//GeneEBhEJ
	if(bOpenGene){
		return;
	}
	pGeneFrame = new CChildFrame;
	pGeneDoc = new CIonDoc;
	pGeneDoc->SetTitle("Gene View");

	CCreateContext context;
	context.m_pCurrentDoc = pGeneDoc;
	context.m_pNewViewClass = RUNTIME_CLASS(kGeneView);
	context.m_pNewDocTemplate = pGeneTemplate;
	context.m_pLastView = (((CMainFrame*) m_pMainWnd)->GetActiveWindow()
		? ((CMainFrame*)m_pMainWnd)->GetActiveFrame()->GetActiveView()
		: NULL);
	context.m_pCurrentFrame = ((CMainFrame*)m_pMainWnd)->GetActiveFrame();

//	if(!pGeneFrame->LoadFrame(IDR_KGENEVIEW_TMPL,
	if(!pGeneFrame->LoadFrame(IDR_IONTYPE,
		WS_OVERLAPPEDWINDOW | FWS_PREFIXTITLE | FWS_ADDTOTITLE,
		m_pMainWnd,&context)){
			return;
	}
	pGeneFrame->InitialUpdateFrame(pGeneDoc,true);

	bOpenGene = true;

}

void CIonApp::closeWindowGene()
{
	if(!bOpenGene){
		return;
	}
	bOpenGene = false;
	pGeneDoc = NULL;
	pGeneFrame = NULL;
}

bool CIonApp::bOpenDaughter = false;//QdI[vh

bool CIonApp::getOpenWindowDaughter()
{
	return bOpenDaughter;
}

void CIonApp::openWindowDaughter()
{
	//DaughterEBhEJ
	if(bOpenDaughter){
		return;
	}
	pDaughterFrame = new CChildFrame;
	pDaughterDoc = new CIonDoc;
	pDaughterDoc->SetTitle("Daughter View");

	CCreateContext context;
	context.m_pCurrentDoc = pDaughterDoc;
	context.m_pNewViewClass = RUNTIME_CLASS(kDaughterView);
	context.m_pNewDocTemplate = pDaughterTemplate;
	context.m_pLastView = (((CMainFrame*) m_pMainWnd)->GetActiveWindow()
		? ((CMainFrame*)m_pMainWnd)->GetActiveFrame()->GetActiveView()
		: NULL);
	context.m_pCurrentFrame = ((CMainFrame*)m_pMainWnd)->GetActiveFrame();

//	if(!pDaughterFrame->LoadFrame(IDR_KDaughterVIEW_TMPL,
	if(!pDaughterFrame->LoadFrame(IDR_IONTYPE,
		WS_OVERLAPPEDWINDOW | FWS_PREFIXTITLE | FWS_ADDTOTITLE,
		m_pMainWnd,&context)){
			return;
	}
	pDaughterFrame->InitialUpdateFrame(pDaughterDoc,true);

	bOpenDaughter = true;

}

void CIonApp::closeWindowDaughter()
{
	if(!bOpenDaughter){
		return;
	}
	bOpenDaughter = false;
	pDaughterDoc = NULL;
	pDaughterFrame = NULL;
}

bool CIonApp::bOpenMother = false;//QdI[vh

bool CIonApp::getOpenWindowMother()
{
	return bOpenMother;
}

void CIonApp::openWindowMother()
{
	//MotherEBhEJ
	if(bOpenMother){
		return;
	}
	pMotherFrame = new CChildFrame;
	pMotherDoc = new CIonDoc;
	pMotherDoc->SetTitle("Mother View");

	CCreateContext context;
	context.m_pCurrentDoc = pMotherDoc;
	context.m_pNewViewClass = RUNTIME_CLASS(kMotherView);
	context.m_pNewDocTemplate = pMotherTemplate;
	context.m_pLastView = (((CMainFrame*) m_pMainWnd)->GetActiveWindow()
		? ((CMainFrame*)m_pMainWnd)->GetActiveFrame()->GetActiveView()
		: NULL);
	context.m_pCurrentFrame = ((CMainFrame*)m_pMainWnd)->GetActiveFrame();

//	if(!pMotherFrame->LoadFrame(IDR_KMotherVIEW_TMPL,
	if(!pMotherFrame->LoadFrame(IDR_IONTYPE,
		WS_OVERLAPPEDWINDOW | FWS_PREFIXTITLE | FWS_ADDTOTITLE,
		m_pMainWnd,&context)){
			return;
	}
	pMotherFrame->InitialUpdateFrame(pMotherDoc,true);

	bOpenMother = true;

}

void CIonApp::closeWindowMother()
{
	if(!bOpenMother){
		return;
	}
	bOpenMother = false;
	pMotherDoc = NULL;
	pMotherFrame = NULL;
}

bool CIonApp::bOpenSize = false;//QdI[vh

bool CIonApp::getOpenWindowSize()
{
	return bOpenSize;
}

void CIonApp::openWindowSize()
{
	//SizeEBhEJ
	if(bOpenSize){
		return;
	}
	pSizeFrame = new CChildFrame;
	pSizeDoc = new CIonDoc;
	pSizeDoc->SetTitle("Size View");

	CCreateContext context;
	context.m_pCurrentDoc = pSizeDoc;
	context.m_pNewViewClass = RUNTIME_CLASS(kSizeView);
	context.m_pNewDocTemplate = pSizeTemplate;
	context.m_pLastView = (((CMainFrame*) m_pMainWnd)->GetActiveWindow()
		? ((CMainFrame*)m_pMainWnd)->GetActiveFrame()->GetActiveView()
		: NULL);
	context.m_pCurrentFrame = ((CMainFrame*)m_pMainWnd)->GetActiveFrame();

//	if(!pSizeFrame->LoadFrame(IDR_KSizeVIEW_TMPL,
	if(!pSizeFrame->LoadFrame(IDR_IONTYPE,
		WS_OVERLAPPEDWINDOW | FWS_PREFIXTITLE | FWS_ADDTOTITLE,
		m_pMainWnd,&context)){
			return;
	}
	pSizeFrame->InitialUpdateFrame(pSizeDoc,true);

	bOpenSize = true;

}

void CIonApp::closeWindowSize()
{
	if(!bOpenSize){
		return;
	}
	bOpenSize = false;
	pSizeDoc = NULL;
	pSizeFrame = NULL;
}

mMother* CIonApp::getMother()
{
	return Mayu;
}

mDaughter* CIonApp::getChild()
{
	if(Mayu){
		return Mayu->getChild();
	}
	return NULL;
}

int CIonApp::ExitInstance() 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	if(Mayu){
		waitFile();
		fileLock();
		kMessage m;
		m.makeDialog();
		m.setText("Ion :: t@Cݒ");
		Mayu->selfSave(pathName);
		m.destroyDialog();
		fileUnlock();
		delete Mayu;
	}
	Mayu = NULL;
	if(control){
		delete control;
	}
	control = NULL;
	return CWinApp::ExitInstance();
}

void CIonApp::OnMenuitemControl() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(Mayu){
		control->DoModal();
	}else{
		AfxMessageBox("t@C̓ǂݍ݂sĂ");
	}
}

void CIonApp::OnMenuitemWinmaneSeed() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	openWindowSeed();
}

void CIonApp::OnUpdateMenuitemWinmaneSeed(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	pCmdUI->Enable(!getOpenWindowSeed());
}

void CIonApp::OnMenuitemWinmaneGene() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	openWindowGene();	
}

void CIonApp::OnUpdateMenuitemWinmaneGene(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	pCmdUI->Enable(!getOpenWindowGene());
	
}

void CIonApp::OnMenuitemWinmaneDaughter() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	openWindowDaughter();
}

void CIonApp::OnUpdateMenuitemWinmaneDaughter(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	pCmdUI->Enable(!getOpenWindowDaughter());
}

void CIonApp::OnMenuitemWinmaneMother() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	openWindowMother();
}

void CIonApp::OnUpdateMenuitemWinmaneMother(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	pCmdUI->Enable(!getOpenWindowMother());
}

void CIonApp::OnMenuitemWinmaneSize() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	openWindowSize();	
}

void CIonApp::OnUpdateMenuitemWinmaneSize(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	pCmdUI->Enable(!getOpenWindowSize());
	
}

kControl* CIonApp::getControl()
{
	return control;
}

kSeedView* CIonApp::getSeedView()
{
	return pSeedView;
}

void CIonApp::setSeedView(kSeedView *SeedView)
{
	pSeedView = SeedView;
}

kGeneView* CIonApp::getGeneView()
{
	return pGeneView;
}

void CIonApp::setGeneView(kGeneView *GeneView)
{
	pGeneView = GeneView;
}

kDaughterView* CIonApp::getDaughterView()
{
	return pDaughterView;
}

void CIonApp::setDaughterView(kDaughterView *DaughterView)
{
	pDaughterView = DaughterView;
}

kMotherView* CIonApp::getMotherView()
{
	return pMotherView;
}

void CIonApp::setMotherView(kMotherView *MotherView)
{
	pMotherView = MotherView;
}

kSizeView* CIonApp::getSizeView()
{
	return pSizeView;
}

void CIonApp::setSizeView(kSizeView *SizeView)
{
	pSizeView = SizeView;
}

CString CIonApp::getPathName()
{
	return pathName;
}

void CIonApp::setPathName(CString pathName)
{
	//͏ݒ̂ƂȊO͎gpȂ
	this->pathName = pathName;
}

void CIonApp::fileLock()
{
	b_isFileAccess = true;
}

void CIonApp::fileUnlock()
{
	b_isFileAccess = false;
}

void CIonApp::waitFile()
{
	while(b_isFileAccess){
	}
}

void CIonApp::logSave()
{
	waitFile();
	fileLock();
	mDaughter* child = getChild();
	mSeedList* seedList = child->getSeedList();
	mGeneList* geneList = child->getGeneList();
	mField* field = child->getField();
	mEnergy* energy = seedList->getEnergy();

	mInt seedNumber = seedList->getSeedVector()->size();
	
	CTime currentTime = CTime::GetCurrentTime();
	time_t c_time = currentTime.GetTime();
	logSaveIn("c_time.log",c_time); //݂̎(O\L)

	mDouble edgeEnergy = energy->calculateEdgeEnergy();
	mDouble leafEnergy = energy->calculateLeafEnergy();
	mDouble flowerEnergy = energy->calculateFlowerEnergy();
	mDouble totalThirdEnergy = edgeEnergy+leafEnergy+flowerEnergy;

	logSaveIn("edge.log",edgeEnergy); //}ɎgGlM[
	logSaveIn("leaf.log", leafEnergy); //tɎgGlM[
	logSaveIn("flower.log", flowerEnergy); //ԂɎgGlM[

	logSaveIn("per_edge.log",edgeEnergy/totalThirdEnergy*100.0); //}ɎgGlM[̃p[Zg
	logSaveIn("per_leaf.log", leafEnergy/totalThirdEnergy*100.0); //tɎgGlM[̃p[Zg
	logSaveIn("per_flower.log", flowerEnergy/totalThirdEnergy*100.0); //ԂɎgGlM[̃p[Zg

	logSaveIn("seed_num.log", seedNumber); //V[h̐
	logSaveIn("gene_num.log", geneList->getGeneNumber()); //`q̐
	logSaveIn("ave_eva.log", seedList->getAverageEvaluationValue()); //ϕ]l
	logSaveIn("ave_size.log", seedList->getAverageSize());//σTCY
	logSaveIn("ave_turn.log", seedList->getAverageTurnNumber());//σ^[
	logSaveIn("ave_ene.log", energy->getCurrentEnergy());//σJgGlM[
	logSaveIn("cur_bir.log", seedList->getCurrentBirthNumber()); //݂̒a
	logSaveIn("cur_dea.log", seedList->getCurrentDeathNumber()); //݂̎Ő
	logSaveIn("fie_cap.log", field->getCapacity());//tB[h̃LpVeB[
	logSaveIn("birth.log", seedList->getBirthNumber()); //a
	logSaveIn("death.log", seedList->getDeathNumber()); //Ő

	logSaveIn("tot_ene.log", field->getTotalEnergy()); //݂܂ł̑GlM[
	logSaveIn("tot_edge.log", energy->calculateEdgeEnergy()*seedNumber ); //}ɎgGlM[̑S
	logSaveIn("tot_leaf.log", energy->calculateLeafEnergy()*seedNumber ); //tɎgGlM[̑S
	logSaveIn("tot_flow.log", energy->calculateFlowerEnergy()*seedNumber ); //ԂɎgGlM[̑S
	logSaveIn("tot_get.log", energy->getTotalEnergy()*seedNumber); //݂܂ł̂ꂽGlM[
	logSaveIn("tot_used.log", energy->getUsedEnergy()*seedNumber); //݂܂łɎgpGlM[
	logSaveIn("tot_keep.log", energy->getKeepEnergy()*seedNumber); //ȈێɎgpGlM[

	logSaveIn("ave_get.log", energy->getTotalEnergy()); //ꂽGlM[̕ϒl
	logSaveIn("ave_used.log", energy->getUsedEnergy()); //gpGlM[̕ϒl
	logSaveIn("ave_keep.log", energy->getKeepEnergy()); //ȈێGlM[̕ϒl

	logSaveIn("ope_ene.log", energy); //Iy[^Ƃ̃GlM[
	fileUnlock();
}

void CIonApp::logSaveIn(const CString& filename, const mDouble& value)
{
	const CString fileNameIn = pathName+filename;
	ofstream os;
	os.open(fileNameIn.operator LPCTSTR(),ios::app);
		//ǉpɊJ
	const int print_size=10;
	os << setprecision(print_size); 
	os << getChild()->getCurrentTime() << ' ' << value << endl;
	os.close();

}

void CIonApp::logSaveIn(const CString& filename, const mInt& value)
{
	const CString fileNameIn = pathName+filename;
	ofstream os;
	os.open(fileNameIn.operator LPCTSTR(),ios::app);
		//ǉpɊJ
	os << getChild()->getCurrentTime() << ' '<< value << endl;
	os.close();
}

void CIonApp::logSaveIn(const CString& filename, const long& value)
{
	//̓OłԃOp
	const CString fileNameIn = pathName+filename;
	ofstream os;
	os.open(fileNameIn.operator LPCTSTR(),ios::app);
		//ǉpɊJ
	struct tm *newtime;
	newtime = localtime(&value);  //  tm \̌`ɕϊ 

	os << getChild()->getCurrentTime() << ' '
		<< ((value+60*60*9) % (60*60*24)) << ' ' //{ԂŌߑO0牽bo߂Ă邩
		<< value << ' ' << asctime(newtime);
	os.close();
}

void CIonApp::logSaveIn(const CString &filename, mEnergy *energy)
{
	const CString fileNameIn = pathName+filename;
	ofstream os;
	os.open(fileNameIn.operator LPCTSTR(),ios::app);
		//ǉpɊJ
	const int print_size=10;
	os << setprecision(print_size); 

	os << getChild()->getCurrentTime() << ' ';
	for(mInt i=0;i<mCPU::OperatorNumber;++i){
		os << energy->getOperatorEnergy(i) <<' ';
	}
	os << endl;
	os.close();

}

void CIonApp::logTurnLogSave()
{
	mDaughter* child = getChild();
	if(child->getTurnNumber() != mParameter::mDaughter_log_turn){
		//̓OƂł͂Ȃ
		return;
	}

	waitFile();
	fileLock();
	const CString fileNameIn = pathName+"log_turn.log";
	ofstream os;
	os.open(fileNameIn.operator LPCTSTR());
	const int print_size=10;
	os << setprecision(print_size); 

	mSeedList* seedList = child->getSeedList();
	mGeneList* geneList = child->getGeneList();
	mField* field = child->getField();
	mEnergy* energy = seedList->getEnergy();

	os<<"turn_number" << " " << child->getTurnNumber() << " //OƂ̃^[" <<endl;

	mInt seedNumber = seedList->getSeedVector()->size();
	os<<"c_time.log"<<" "<< child->getCurrentTime()<<  " //݂܂ł̎s" <<endl;

	mDouble edgeEnergy = energy->calculateEdgeEnergy();
	mDouble leafEnergy = energy->calculateLeafEnergy();
	mDouble flowerEnergy = energy->calculateFlowerEnergy();
	mDouble totalThirdEnergy = edgeEnergy+leafEnergy+flowerEnergy;

	os<<"edge.log"<<" "<< edgeEnergy<<  " //}ɎgGlM[" <<endl;
	os<<"leaf.log"<<" "<<  leafEnergy<<  " //tɎgGlM[" <<endl;
	os<<"flower.log"<<" "<<  flowerEnergy<<  " //ԂɎgGlM[" <<endl;

	os<<"per_edge.log"<<" "<< edgeEnergy/totalThirdEnergy*100.0<<  " //}ɎgGlM[̃p[Zg" <<endl;
	os<<"per_leaf.log"<<" "<< leafEnergy/totalThirdEnergy*100.0<<  " //tɎgGlM[̃p[Zg" <<endl;
	os<<"per_flower.log"<<" "<< flowerEnergy/totalThirdEnergy*100.0<<  " //ԂɎgGlM[̃p[Zg" <<endl;

	os<<"seed_num.log"<<" "<<  seedNumber<<  " //V[h̐"<<endl;
	os<<"gene_num.log"<<" "<<  geneList->getGeneNumber()<<  " //`q̐" <<endl;
	os<<"ave_eva.log"<<" "<<  seedList->getAverageEvaluationValue()<<  " //ϕ]l" <<endl;
	os<<"ave_size.log"<<" "<<  seedList->getAverageSize()<< " //σTCY" <<endl;
	os<<"ave_turn.log"<<" "<<  seedList->getAverageTurnNumber()<< " //σ^[" <<endl;
	os<<"ave_ene.log"<<" "<<  energy->getCurrentEnergy()<< " //σJgGlM[" <<endl;
	os<<"cur_bir.log"<<" "<<  seedList->getCurrentBirthNumber()<<  " //݂̒a" <<endl;
	os<<"cur_dea.log"<<" "<<  seedList->getCurrentDeathNumber()<<  " //݂̎Ő" <<endl;
	os<<"fie_cap.log"<<" "<<  field->getCapacity()<< " //tB[h̃LpVeB[" <<endl;
	os<<"birth.log"<<" "<<  seedList->getBirthNumber()<<  " //a" <<endl;
	os<<"death.log"<<" "<<  seedList->getDeathNumber()<<  " //Ő" <<endl;

	os<<"tot_ene.log"<<" "<<  field->getTotalEnergy()<<  " //݂܂ł̑GlM[" <<endl;
	os<<"tot_edge.log"<<" "<<  energy->calculateEdgeEnergy()*seedNumber <<  " //}ɎgGlM[̑S" <<endl;
	os<<"tot_leaf.log"<<" "<<  energy->calculateLeafEnergy()*seedNumber <<  " //tɎgGlM[̑S" <<endl;
	os<<"tot_flow.log"<<" "<<  energy->calculateFlowerEnergy()*seedNumber <<  " //ԂɎgGlM[̑S" <<endl;
	os<<"tot_get.log"<<" "<<  energy->getTotalEnergy()*seedNumber<<  " //݂܂ł̂ꂽGlM[" <<endl;
	os<<"tot_used.log"<<" "<<  energy->getUsedEnergy()*seedNumber<<  " //݂܂łɎgpGlM[" <<endl;
	os<<"tot_keep.log"<<" "<<  energy->getKeepEnergy()*seedNumber<<  " //ȈێɎgpGlM[" <<endl;

	os<<"ave_get.log"<<" "<<  energy->getTotalEnergy()<<  " //ꂽGlM[̕ϒl" <<endl;
	os<<"ave_used.log"<<" "<<  energy->getUsedEnergy()<<  " //gpGlM[̕ϒl" <<endl;
	os<<"ave_keep.log"<<" "<<  energy->getKeepEnergy()<<  " //ȈێGlM[̕ϒl" <<endl;

	fileUnlock();
}

void CIonApp::OnMenuitemSaveBirdView() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(AfxMessageBox("BirdViewf[^Z[u܂",MB_YESNO)!=IDYES){
		return;
	}
	waitFile();
	fileLock();

	CFileDialog fileDialog(false,"view","birdview.view",
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT ,
		"Bird Eye Files (*.view)|*.view||",m_pMainWnd);
	fileDialog.m_ofn.lpstrInitialDir = getPathName();
	if(fileDialog.DoModal()!=IDOK){
		fileUnlock();
		return;
	}
	kMessage m;
	m.makeDialog();
	m.setText("Ion :: o[hr[t@Cݒ");
	CString fileName = fileDialog.GetPathName();
	ofstream os(fileName);
	getChild()->saveBirdView(os);
	m.destroyDialog();
	fileUnlock();
}


void CIonApp::forceExit()
{
	//IɏI
	//Aق̏[N
	//i38oCgقǁj
	AfxGetMainWnd()->SendMessage(WM_CLOSE);
	if(Mayu){
		delete Mayu;
	}
	Mayu = NULL;
	if(control){
		delete control;
	}
	control = NULL;
	exit(0);
}

void CIonApp::openInitialWindows()
{
	//openWindowSize();
	//openWindowSeed();
	//openWindowGene();
	//openWindowDaughter();
	//openWindowMother();

}


CString CIonApp::getExecutePath()
{
	return executePath;
}
