// kMotherView.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "Ion.h"
#include "kMotherView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// kMotherView

IMPLEMENT_DYNCREATE(kMotherView, CFormView)

kMotherView::kMotherView()
	: CFormView(kMotherView::IDD)
{
	//{{AFX_DATA_INIT(kMotherView)
	//}}AFX_DATA_INIT
	((CIonApp*)AfxGetApp())->setMotherView(this);
}

kMotherView::~kMotherView()
{
	((CIonApp*)AfxGetApp())->closeWindowMother();
	((CIonApp*)AfxGetApp())->setMotherView(NULL);
}

void kMotherView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(kMotherView)
	DDX_Control(pDX, IDC_BUTTON_PRE_EXECUTE, m_pre_execute);
	DDX_Control(pDX, IDC_BUTTON_EXECUTE, m_execute);
	DDX_Control(pDX, IDC_BUTTON_SUN_LIGHT, m_sun_light);
	DDX_Control(pDX, IDC_BUTTON_INITIAL_EXECUTE, m_initial_execute);
	DDX_Control(pDX, IDC_BUTTON_AFTER_EXECUTE, m_after_execute);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(kMotherView, CFormView)
	//{{AFX_MSG_MAP(kMotherView)
	ON_BN_CLICKED(IDC_BUTTON_SUN_LIGHT, OnButtonSunLight)
	ON_BN_CLICKED(IDC_BUTTON_INITIAL_EXECUTE, OnButtonInitialExecute)
	ON_BN_CLICKED(IDC_BUTTON_EXECUTE, OnButtonExecute)
	ON_BN_CLICKED(IDC_BUTTON_AFTER_EXECUTE, OnButtonAfterExecute)
	ON_BN_CLICKED(IDC_BUTTON_PRE_EXECUTE, OnButtonPreExecute)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// kMotherView ff

#ifdef _DEBUG
void kMotherView::AssertValid() const
{
	CFormView::AssertValid();
}

void kMotherView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// kMotherView bZ[W nh


void kMotherView::currentView(mInt currentState)
{
	m_execute.EnableWindow(false);
	m_pre_execute.EnableWindow(false);
	m_sun_light.EnableWindow(false);
	m_initial_execute.EnableWindow(false);
	m_after_execute.EnableWindow(false);

	switch(currentState){
	case mMother::PRE_EXECUTE:
		m_pre_execute.EnableWindow(true);
		break;
	case mMother::EXECUTE:
		m_execute.EnableWindow(true);
		break;
	case mMother::INITIAL_EXECUTE:
		m_initial_execute.EnableWindow(true);
		break;
	case mMother::AFTER_EXECUTE:
		m_after_execute.EnableWindow(true);
		break;
	case mMother::SUN_LIGHT:
		m_sun_light.EnableWindow(true);
		break;
	default:
		break;
	}
}

void kMotherView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	if(((CIonApp*)AfxGetApp())->getMother()){
		currentView(((CIonApp*)AfxGetApp())->getMother()->getCurrentState());
	}
}

void kMotherView::OnButtonSunLight() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	callControl();
}

void kMotherView::OnButtonInitialExecute() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	callControl();	
}

void kMotherView::OnButtonPreExecute() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	callControl();
}

void kMotherView::OnButtonExecute() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	callControl();	
}

void kMotherView::OnButtonAfterExecute() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	callControl();	
}

void kMotherView::callControl()
{
	((CIonApp*)AfxGetApp())->OnMenuitemControl();
}

