// kTarget.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "Ion.h"
#include "kTarget.h"
#include "kMessage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// kTarget _CAO


kTarget::kTarget(CWnd* pParent /*=NULL*/)
	: CDialog(kTarget::IDD, pParent)
{
	//{{AFX_DATA_INIT(kTarget)
	//}}AFX_DATA_INIT
	dc = NULL;
}


void kTarget::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(kTarget)
	DDX_Control(pDX, IDC_EDIT_EVAL, m_edit_eval);
	DDX_Control(pDX, IDC_EDIT_ID, m_edit_id);
	DDX_Control(pDX, IDC_BUTTON_EXEC, m_button_exec);
	DDX_Control(pDX, IDC_LIST_REGISTER, m_list_register);
	DDX_Control(pDX, IDC_EDIT_CALORIE, m_edit_calorie);
	DDX_Control(pDX, IDC_SCROLLBAR_DISTANCE, m_scroll_distance);
	DDX_Control(pDX, IDC_SCROLLBAR_ANGLE, m_scroll_angle);
	DDX_Control(pDX, IDC_LIST_PARTS, m_list_parts);
	DDX_Control(pDX, IDC_EDIT_VOLUME, m_edit_volume);
	DDX_Control(pDX, IDC_EDIT_EXEC, m_edit_exec);
	DDX_Control(pDX, IDC_EDIT_ENERGY, m_edit_energy);
	DDX_Control(pDX, IDC_EDIT_DONE, m_edit_done);
	DDX_Control(pDX, IDC_EDIT_CODE, m_edit_code);
	DDX_Control(pDX, IDC_EDIT_ABUFF, m_edit_abuff);
	DDX_Control(pDX, IDC_COMBO_PARTS, m_combo_parts);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(kTarget, CDialog)
	//{{AFX_MSG_MAP(kTarget)
	ON_CBN_SELCHANGE(IDC_COMBO_PARTS, OnSelchangeComboParts)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_BUTTON_EXEC, OnButtonExec)
	ON_WM_CLOSE()
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_BUTTON_SAVE_CODE, OnButtonSaveCode)
	ON_BN_CLICKED(IDC_BUTTON_BMP_SAVE, OnButtonBmpSave)
	ON_BN_CLICKED(IDC_BUTTON_VIEW_SAVE, OnButtonViewSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// kTarget bZ[W nh

kTarget::kTarget(mSeed *targetSeed)
	: CDialog(kTarget::IDD, NULL)
{
	this->targetSeed = targetSeed;
	isCodeDisplay = false;
}

BOOL kTarget::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	if(targetSeed == NULL){
		AfxMessageBox("V[h̎w肪s\ł");
		OnOK();
	}
	
	dc = new CClientDC(GetDlgItem(IDC_PICT));
	m_scroll_angle.SetScrollRange(0,255);
	m_scroll_distance.SetScrollRange(0,255);
	m_scroll_angle.SetScrollPos(128);
	m_scroll_distance.SetScrollPos(128);

	dataDisplay();

	if(targetSeed->getSeedList()==NULL){
		m_button_exec.EnableWindow(true);
	}

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void kTarget::dataDisplay()
{
	registerDisplay();
	codeDisplay();
	m_edit_done.SetWindowText(targetSeed->getCPU()->getDoneWork());
	m_edit_abuff.SetWindowText(targetSeed->getPartsList()->getABuffer());
	m_edit_id.SetWindowText(targetSeed->getID()->toString());
	m_edit_energy.SetWindowText(targetSeed->getCPU()->getEnergy()->makeString());
	setData(m_edit_eval,targetSeed->getEvaluationValue());
	setData(m_edit_exec,targetSeed->getTurnNumber());
	OnSelchangeComboParts(); //Ńp[cXg̒gς͂
	drawTree();//tree
}

void kTarget::registerDisplay()
{
	int nn,i;
	nn = m_list_register.GetCount();
	for( i = nn-1; i>=0 ;--i){
		m_list_register.DeleteString(i);
	}
	CString newString;
	mCPU* CPU = targetSeed->getCPU();

	newString.Format("ip : %d",CPU->getIP());
	m_list_register.InsertString(-1,newString);

	newString.Format("register : %s",
		mCPU::RegisterName[CPU->getRegisterIndex()]);
	m_list_register.InsertString(-1,newString);

	m_list_register.InsertString(-1,"");

	mDouble* registers = CPU->getRegisters();
	for(i=0;i<mCPU::RegistersNumber;++i){
		newString.Format("%s : %lf",
			mCPU::RegisterName[i],
			registers[i]);
		m_list_register.InsertString(-1,newString);
	}
}

void kTarget::codeDisplay()
{
	if(isCodeDisplay==false){
		m_edit_code.SetWindowText(targetSeed->getGene()->makeCodeString());
		isCodeDisplay = true;
	}
}

template<class T>
static void listDisplay(vector<T*>* dlist,CListBox& box)
{
	if(dlist == NULL){
		return;
	}
	CString newString;
	vector<T*>::iterator it;
	int i = 0;
	for(it = dlist->begin(); it != dlist->end() ; ++it ,++i){
		if(*it){
			mPoint3D* centerPoint3D = (*it)->getCenterPoint3D();
			newString.Format("%d : %.2lf,%.2lf,%.2lf,%.2lf",
				i,
				centerPoint3D->x,
				centerPoint3D->y,
				centerPoint3D->z,
				(*it)->getRadius());
			box.InsertString(-1,newString);
		}
	}
}

void kTarget::OnSelchangeComboParts() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	const int index = m_combo_parts.GetCurSel();
	if(index == CB_ERR){
		return;
	}
	int nn,i;
	nn = m_list_parts.GetCount();
	for( i = nn-1; i>=0 ;--i){
		m_list_parts.DeleteString(i);
	}

	mPartsList* partsList = targetSeed->getPartsList();
	if(partsList == NULL){
		return;
	}
	switch(index){
	case 0: //}Ƃ
		{
		CString newString;
		vector<mEdge*>::iterator it;
		int i = 0;
		vector<mEdge*>* dlist = partsList->getEdgeList();
		for(it = dlist->begin(); it != dlist->end() ; ++it ,++i){
			mPoint3D* centerPoint3D = (*it)->getCenterPoint3D();
			mPoint3D* endPoint3D = (*it)->getEndPoint3D();
			newString.Format("%d : %.2lf,%.2lf,%.2lf,%.2lf,%.2lf,%.2lf",
				i,
				centerPoint3D->x,
				centerPoint3D->y,
				centerPoint3D->z,
				endPoint3D->x,
				endPoint3D->y,
				endPoint3D->z);
			m_list_parts.InsertString(-1,newString);
		}
		setData(m_edit_calorie,partsList->getEdgeCalorie());
		setData(m_edit_volume,partsList->getEdgeVolume());
		break;
		}
	case 1: //tƂ
		listDisplay<mLeaf>(partsList->getLeafList(),m_list_parts);
		setData(m_edit_calorie,partsList->getLeafCalorie());
		setData(m_edit_volume,partsList->getLeafVolume());
		break;
	case 2: //ԂƂ
		listDisplay<mFlower>(partsList->getFlowerList(),m_list_parts);
		setData(m_edit_calorie,partsList->getFlowerCalorie());
		setData(m_edit_volume,partsList->getFlowerVolume());
		break;
	case 3: //m[hƂ
		{
			vector<mNode*>* nodeList = partsList->getNodeList();
			if(nodeList == NULL){
				return;
			}
			CString newString;
			vector<mNode*>::iterator it;
			int i = 0;
			for(it = nodeList->begin(); it != nodeList->end() ; ++it ,++i){
				if(*it){
					mPoint3D* centerPoint3D = (*it)->getCenterPoint3D();
					newString.Format("%d : %.2lf,%.2lf,%.2lf",
						i,
						centerPoint3D->x,
						centerPoint3D->y,
						centerPoint3D->z);
					m_list_parts.InsertString(-1,newString);
				}
			}

			setData(m_edit_calorie,0.0);
			setData(m_edit_volume,0.0);
			break;
		}
	case 4: //V[hƂ
		{
			CString newString;
			mPoint3D* centerPoint3D = targetSeed->getCenterPoint3D();
			newString.Format(" %.2lf,%.2lf,%.2lf",
				centerPoint3D->x,
				centerPoint3D->y,
				centerPoint3D->z);
			m_list_parts.InsertString(-1,newString);
			setData(m_edit_calorie,mParameter::mSeed_calorie);
			setData(m_edit_volume,mParameter::mSeed_volume);
		}
		break;
	}

}

void kTarget::setData(CEdit &edit, const mInt value)
{
	CString newString;
	newString.Format("%d",value);
	edit.SetWindowText(newString);
}

void kTarget::setData(CEdit &edit, const mDouble value)
{
	CString newString;
	newString.Format("%lf",value);
	edit.SetWindowText(newString);
}

void kTarget::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	int pos = pScrollBar->GetScrollPos();
	switch(nSBCode){
	case SB_LEFT:
		pos = 0 ; break;
	case SB_RIGHT:
		pos = 255 ; break;
	case SB_LINELEFT:
		--pos ; break;
	case SB_LINERIGHT:
		++pos ; break;
	case SB_PAGELEFT:
		pos -= 16; break;
	case SB_PAGERIGHT:
		pos += 16; break;
	case SB_THUMBPOSITION:
		pos = nPos; break;
	case SB_THUMBTRACK:
		break;
	case SB_ENDSCROLL:
		break;
	}
	if(pos<0){
		pos =255;
	}else if(pos>255){
		pos = 0;
	}
	pScrollBar->SetScrollPos(pos);

	drawTree();
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

mDouble kTarget::getAngle()
{
	int pos = m_scroll_angle.GetScrollPos();
	const mDouble min = -PI;
	const mDouble max = PI;
	const mDouble angle = min+(max-min)*((mDouble)pos)/256;
	return angle;
}

mDouble kTarget::getDistance()
{
	int pos = m_scroll_distance.GetScrollPos();
	const mDouble min = -1.0;
	const mDouble max = 1.0;
	const mDouble power = min+(max-min)*((mDouble)pos)/256.0;
	const double distance = pow(2.0,power);
	return distance;

}

void kTarget::OnButtonExec() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	targetSeed->getCPU()->getEnergy()->addTotalEnergy(calculateSun());
	//GlM[𓾂Ƃ`Ă
	targetSeed->execute();
	//ۂexecute
	dataDisplay();
}

void kTarget::drawTree()
{
	paintClear();
	paintFlower();
	paintLeaf();
	paintEdge();
	paintAxis();
}

CPoint kTarget::calculateCoordinate(mPoint3D *point)
{
	const double phy = getAngle();
	const double distance = getDistance();
	mPoint3D* center = targetSeed->getCenterPoint3D();
	const double x = point->x - center->x;
	const double y = point->y - center->y;
	const double z = point->z - center->z;
	const double x1 = x * cos(phy) - y * sin(phy);
	const double y1 = x * sin(phy) + y * cos(phy);
	const double x2 = sqrt(3.0)/2*(x1-y1);
	const double y2 = z-(x1+y1)/2.0;
	
	const r = distance * 5.0;

	const double x3 = r*x2;
	const double y3 = r*y2;
	CPoint p;
	CRect myRECT;
	((CWnd*)GetDlgItem(IDC_PICT))->GetClientRect(myRECT);
	p.x = (int)x3+(int)((mDouble)myRECT.Width()/2.0);
	p.y = -(int)y3+(int)((mDouble)myRECT.Height()*0.750);
	return p;
}

void kTarget::paintChar(mPoint3D *center, mDouble radius)
{
	const CPoint p = calculateCoordinate(center);
	const double r = radius*getDistance()*5.0;
	dc->Arc(p.x-r,p.y-r,p.x+r,p.y+r,
			p.x-r,p.y-r,p.x-r,p.y-r);
}

void kTarget::paintLine(mPoint3D *start, mPoint3D *end)
{
	CPoint pStart = calculateCoordinate(start);
	CPoint pEnd = calculateCoordinate(end);
	dc->MoveTo(pStart);
	dc->LineTo(pEnd);
}

void kTarget::OnClose() 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	if(dc){
		delete dc;
		dc = NULL;
	}
	dc = NULL;
	CDialog::OnClose();
}

void kTarget::paintFlower()
{
	CPen myPen,*oldPen;
	myPen.CreatePen(PS_SOLID,1,RGB(255,0,0));
	oldPen = dc->SelectObject(&myPen);
	vector<mFlower*>* flowerList = targetSeed->getPartsList()->getFlowerList();
	if(flowerList == NULL){
		return;
	}
	for(vector<mFlower*>::iterator it = flowerList->begin();
			it != flowerList->end();
			++it){
		paintChar((*it)->getCenterPoint3D(),(*it)->getRadius());
	}
	dc->SelectObject(oldPen);
}

void kTarget::paintLeaf()
{
	CPen myPen,*oldPen;
	myPen.CreatePen(PS_SOLID,1,RGB(0,255,0));
	oldPen = dc->SelectObject(&myPen);
	vector<mLeaf*>* leafList = targetSeed->getPartsList()->getLeafList();
	if(leafList == NULL){
		return;
	}
	for(vector<mLeaf*>::iterator it = leafList->begin();
			it != leafList->end();
			++it){
		paintChar((*it)->getCenterPoint3D(),(*it)->getRadius());
	}
	dc->SelectObject(oldPen);

}

void kTarget::paintEdge()
{
	CPen myPen,*oldPen;
	myPen.CreatePen(PS_SOLID,1,RGB(0,0,255));
	oldPen = dc->SelectObject(&myPen);
	vector<mEdge*>* edgeList = targetSeed->getPartsList()->getEdgeList();
	if(edgeList == NULL){
		return;
	}
	for(vector<mEdge*>::iterator it = edgeList->begin();
			it != edgeList->end();
			++it){
		paintLine((*it)->getCenterPoint3D(),(*it)->getEndPoint3D());
	}
	//ł̃V[hĂ
	paintChar(targetSeed->getCenterPoint3D(),1.0);
	dc->SelectObject(oldPen);

}


void kTarget::paintAxis()
{
	CPen myPen,*oldPen;
	myPen.CreatePen(PS_SOLID,1,RGB(0,0,0));
	oldPen = dc->SelectObject(&myPen);
	mPoint3D* center = targetSeed->getCenterPoint3D();
	mPoint3D x_base(10.0,0.0,0.0);
	mPoint3D y_base(0.0,10.0,0.0);
	mPoint3D z_base(0.0,0.0,10.0);
	mPoint3D* x_axis = mPoint3D::addPoint3D(center,&x_base);
	mPoint3D* y_axis = mPoint3D::addPoint3D(center,&y_base);
	mPoint3D* z_axis = mPoint3D::addPoint3D(center,&z_base);
	paintLine(center,x_axis);
	paintLine(center,y_axis);
	paintLine(center,z_axis);
	delete x_axis;
	delete y_axis;
	delete z_axis;
	dc->SelectObject(oldPen);
}

void kTarget::paintClear()
{
	CRect myRECT;
	((CWnd*)GetDlgItem(IDC_PICT))->GetClientRect(myRECT);
	dc->FillSolidRect(myRECT,RGB(255,255,255));

}

void kTarget::OnPaint() 
{
	CPaintDC dc(this); // `p̃foCX ReLXg
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	drawTree();
	// `pbZ[WƂ CDialog::OnPaint() ĂяoĂ͂܂
}

mDouble kTarget::calculateSun()
{
	vector<mLeaf*>* leafList = targetSeed->getPartsList()->getLeafList();
	vector<mLeaf*>::iterator it;

	mDouble square = 0.0;
	for(it = leafList->begin() ; it != leafList->end() ; ++it){
		mDouble radius = (*it)->getRadius();
		square += radius*radius;
	}
	square *= PI; //ŗt̖ʐς܂

	const mDouble unitSquare = mParameter::mField_haba * mParameter::mField_haba;
	square /= unitSquare; //łǂꂾ̒Pʖʐς邩
	const mDouble daylight = mParameter::mField_daylight;
	const mDouble downsize = mParameter::mField_downsize;
	return square * daylight * downsize ;
	//ŗt󂯂̂悻̒l
}

kTarget::~kTarget()
{
	if(dc){
		delete dc;
		dc = NULL;
	}
}

void kTarget::OnButtonSaveCode() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	mGene* targetGene = targetSeed->getGene();
	if(targetGene == NULL){
		return;
	}
	CString IDString = targetGene->getID()->toString();
	CString tmpFileName = CString("ID")+IDString+".gene";
	
	CString saveString;
	m_edit_code.GetWindowText(saveString);
	saveString.Remove('\x0a'); //t@CɃZ[uƂ͂ύXĂ

	CFileDialog fileDialog(false,"gene",tmpFileName,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT ,
		"Gene Files (*.gene)|*.gene||",this);
	CIonApp* currentApp = (CIonApp*)AfxGetApp();
	fileDialog.m_ofn.lpstrInitialDir = currentApp->getPathName();

	if(fileDialog.DoModal()==IDOK){
		CString fileName = fileDialog.GetPathName();
		currentApp->waitFile();
		currentApp->fileLock();
		ofstream os(fileName);
		os << "/*----------------------*/" <<endl;
		os << "  this is gene file" << endl;
		os << "  " << IDString << endl;
		os << "/*----------------------*/" <<endl;
		os << saveString << endl;
		os.close();
		currentApp->fileUnlock();
	}
}

BOOL kTarget::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	switch(pMsg->message){
	case WM_KEYDOWN:
		switch(pMsg->wParam){
		case VK_RETURN: return true;
		case VK_ESCAPE: return true;
		}
	}	
	return CDialog::PreTranslateMessage(pMsg);
}

void kTarget::OnButtonBmpSave() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CIonApp* currentApp = (CIonApp*)AfxGetApp();

	CString tmpFileName;
	if(targetSeed->getSeedList()){
		//܂V[ĥق
		tmpFileName = CString("SeedID")+targetSeed->getID()->toString()+".bmp";
	}else{
		tmpFileName = CString("GeneID")+targetSeed->getGene()->getID()->toString()+".bmp";
	}

	CFileDialog fileDialog(false,"bmp",tmpFileName,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT ,
		"Widows Bitmap Files (*.bmp)|*.bmp||",this);
	fileDialog.m_ofn.lpstrInitialDir = currentApp->getPathName();

	if(fileDialog.DoModal()!=IDOK){
		return;
	}
	
	CString filename = fileDialog.GetPathName();
	currentApp->waitFile();
	currentApp->fileLock();
	kMessage k;
	k.makeDialog();
	k.setText("Ion:: BMPt@Cɕۑ");
	saveBMPFile(filename);
	k.destroyDialog();
	currentApp->fileUnlock();

}

void kTarget::saveBMPFile(const CString &filename)
{
	CWnd* PICT = GetDlgItem(IDC_PICT);
	CClientDC dc(PICT);
	CRect Rect;
	PICT->GetClientRect(Rect);
	Rect.NormalizeRect();

	const int width = Rect.Width()-2;
	const int height = Rect.Height()-2;
	COLORREF* colors = new COLORREF[width*height];
	int k = 0;
	drawTree();
	for(int i = height-1 ;i >= 0 ; --i ){
		for(int j = 0 ; j < width ; ++j ){
			colors[k] = dc.GetPixel(j+1,i+1);
			++k;
		}
	}
	makeBMPFile(filename,width,height,colors);
	delete[] colors;
}

void kTarget::makeBMPFile(const CString &filename, const int width, const int height, const COLORREF *colors)
{
	ofstream os(filename.operator LPCTSTR(),ios::out | ios::binary);

	BITMAPFILEHEADER bitmapFileHeader;
	BITMAPINFOHEADER bitmapInfoHeader;
	const int size = width*height;
	const int m = width % sizeof(long);

	const int fileLength = sizeof(BITMAPFILEHEADER)
				+ sizeof(BITMAPINFOHEADER)
				+ sizeof(char)*3*size
				+ sizeof(char)*m*height; //longEւ̒
	bitmapFileHeader.bfType = 'M'*256+'B'; //GfBAœւ
	bitmapFileHeader.bfSize = fileLength;
	bitmapFileHeader.bfReserved1 = 0;
	bitmapFileHeader.bfReserved2 = 0;
	bitmapFileHeader.bfOffBits = sizeof(BITMAPFILEHEADER)
				+ sizeof(BITMAPINFOHEADER);

	bitmapInfoHeader.biSize = sizeof(BITMAPINFOHEADER);
	bitmapInfoHeader.biWidth = width;
	bitmapInfoHeader.biHeight = height;
	bitmapInfoHeader.biPlanes = 1;
	bitmapInfoHeader.biBitCount = 24;
	bitmapInfoHeader.biCompression = BI_RGB;
	bitmapInfoHeader.biSizeImage = 0;
	bitmapInfoHeader.biXPelsPerMeter = 0;
	bitmapInfoHeader.biYPelsPerMeter = 0;
	bitmapInfoHeader.biClrUsed = 0;
	bitmapInfoHeader.biClrImportant = 0;

	os.write((char*)&bitmapFileHeader,sizeof(BITMAPFILEHEADER));
	os.write((char*)&bitmapInfoHeader,sizeof(BITMAPINFOHEADER));
	
	int i;
	char* adjuster = NULL;
	if(m !=0 ){
		adjuster = new char[m];
		for(i = 0 ; i < m ; ++i){
			adjuster[i] = NULL;
		}
	}
	
	char bgr[3];

	for(i = 0 ; i < size ; ++i ){
		COLORREF col = colors[i];
		
		bgr[0] = (char)((col >> 16) & 0xff);
		bgr[1] = (char)((col >> 8) & 0xff);
		bgr[2] = (char)(col & 0xff);
		os.write(bgr,sizeof(bgr));
		if(m != 0 && (i+1) % width == 0){
			os.write(adjuster,m);
		}
	}
	if(adjuster){
		delete[] adjuster;
	}
	os.close();
}

void kTarget::OnButtonViewSave() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CIonApp* currentApp = (CIonApp*)AfxGetApp();

	CString tmpFileName;
	if(targetSeed->getSeedList()){
		//܂V[ĥق
		tmpFileName = CString("SeedID")+targetSeed->getID()->toString()+".view";
	}else{
		tmpFileName = CString("GeneID")+targetSeed->getGene()->getID()->toString()+".view";
	}

	CFileDialog fileDialog(false,"view",tmpFileName,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT ,
		"Bird Eye Files (*.view)|*.view||",this);
	fileDialog.m_ofn.lpstrInitialDir = currentApp->getPathName();

	if(fileDialog.DoModal()!=IDOK){
		return;
	}
	
	CString filename = fileDialog.GetPathName();
	currentApp->waitFile();
	currentApp->fileLock();
	kMessage k;
	k.makeDialog();
	k.setText("Ion:: Viewt@Cɕۑ");
	//---------------------------
	mDaughter* child = currentApp->getChild();
	
	ofstream os(filename);
	os << "/*-----Bird View--------*/" << endl;
	os << "/ turn = " << child->getTurnNumber() << endl;
	os << "/ time = " << child->getCurrentTime() << endl;
	child->getField()->saveBirdView(os);
	os <<targetSeed->toString() <<endl;
	targetSeed->getPartsList()->saveBirdView(os);
	os.close();
	//---------------------------
	k.destroyDialog();
	currentApp->fileUnlock();
	
}
