// mEdge.cpp: mEdge NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Ion.h"
#include "mEdge.h"
#include "mSeed.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

mEdge::mEdge()
{
	endPoint3D=NULL;
}

mEdge::~mEdge()
{
	//endPoint3DdeleteȂ
}

mEdge::mEdge(mSeed *seed, mPoint3D *centerPoint3D, mPoint3D *endPoint3D)
	:mParts(seed,centerPoint3D)
{
	this->endPoint3D=endPoint3D;
}

mPoint3D* mEdge::getEndPoint3D()
{
	return endPoint3D ;
}

CString mEdge::toString()
{
	CString returnString="E "; //En܂͎̂}Ƃ
	returnString+=centerPoint3D->toString();
	returnString+=' ';
	returnString+=endPoint3D->toString();
	returnString+=' ';
	returnString+=seed->getID()->toString();
	return returnString;
}

bool mEdge::canMakeBowl(mPoint3D *otherCenterPoint3D, mDouble radius)
{
	return !isCollsion(otherCenterPoint3D,radius,centerPoint3D,endPoint3D);	
		//ԂȂ΍邵
		//Ԃ΍Ȃ
}

mDouble mEdge::getVolume()
{
	return PI*getLength()
		*mParameter::mEdge_radius
		*mParameter::mEdge_radius;
	//*(r^2)*h
}

mDouble mEdge::getLength()
{
	mPoint3D l;
	l.x=centerPoint3D->x-endPoint3D->x;
	l.y=centerPoint3D->y-endPoint3D->y;
	l.z=centerPoint3D->z-endPoint3D->z;
	return sqrt(l.getLengthSquare());
}

mDouble mEdge::getCalorie()
{
	return getVolume()*mParameter::mEdge_calorie;
}

mDouble mEdge::getKeepCalorie()
{
	return getCalorie()*mParameter::mEdge_keep_calorie;
}

mDouble mEdge::calculateCalorie(mDouble r)
{
	mDouble volume = PI*r
		*mParameter::mEdge_radius
		*mParameter::mEdge_radius;
	//*(r^2)*h
	return volume*mParameter::mEdge_calorie;
}
