// mFlowerLeaf.cpp: mFlowerLeaf NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Ion.h"
#include "mFlowerLeaf.h"
#include "mSeed.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

mFlowerLeaf::mFlowerLeaf():mParts()
{
	radius=0.0;
	lightEnergy=0.0;
}

mFlowerLeaf::~mFlowerLeaf()
{
	if(centerPoint3D){
		delete centerPoint3D; //S_͂ꂼ̃p[cdelete
	}
}



bool mFlowerLeaf::canMakeBowl(mPoint3D *otherCenter, mDouble otherRadius)
{
	//S_
	//g傫ĂƂ
	if(centerPoint3D==otherCenter){
		return true;
	}
	/*
	 2̋̒S_̊Ԃ̃xNg
	 a̘̒aׂ΂
	*/
	mDouble r=radius+otherRadius;
	if(getDistanceSquare(otherCenter)<r*r){
		return false; //ԂĂ܂Ȃ
	}
	return true;
}

bool mFlowerLeaf::canMakeEdge(mPoint3D *otherCenter, mPoint3D *otherEnd)
{
	return !isCollsion(this->centerPoint3D,radius,otherCenter,otherEnd);
		//ԂĂȂ΍邵A
		//ԂĂ΍Ȃ
}

void mFlowerLeaf::setLightEnergy(mDouble lightEnergy)
{
	this->lightEnergy=lightEnergy;
}

mDouble mFlowerLeaf::getLightEnergy()
{
	return lightEnergy;
}

void mFlowerLeaf::setRadius(mDouble radius)
{
	this->radius=radius;
}

mDouble mFlowerLeaf::getRadius()
{
	return radius;
}

mDouble mFlowerLeaf::getVolume()
{
	return 4.0/3.0*PI*radius*radius*radius;
	// 4*(r^3)/3Ă
}

mDouble mFlowerLeaf::getDistanceSquare(mPoint3D *otherCenterPoint3D)
{
	mPoint3D l;
	l.x=centerPoint3D->x-otherCenterPoint3D->x;
	l.y=centerPoint3D->y-otherCenterPoint3D->y;
	l.z=centerPoint3D->z-otherCenterPoint3D->z;
	//2_Ԃ̃xNgĂ̒Ōv
	return l.getLengthSquare();
}

mFlowerLeaf::mFlowerLeaf(mSeed *seed, mPoint3D *centerPoint3D, mDouble radius)
	:mParts(seed,centerPoint3D)
{
	this->radius=radius;
	lightEnergy=0.0;
}

bool mFlowerLeaf::higherThan(mFlowerLeaf *mine, mFlowerLeaf *yours)
{
	// mineyoursłǂ炪𔻒f
	// XgŜ\[g邽߂̊֐
	if(mine->centerPoint3D->z 
			> yours->centerPoint3D->z){
		return true;
		//S_zWƔf
	}
	return false;
}
