// mGeneList.cpp: mGeneList NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Ion.h"
#include "mGeneList.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

mGeneList::mGeneList(mDaughter* daughter)
{
	this->daughter = daughter;
		//̃CX^X͂̃NXłdeleteȂ
	geneVector = NULL;
	geneVector = new vector<mGeneVector*>;
		//̃CX^X͂̃NXdelete邱
}

mGeneList::~mGeneList()
{
	if(geneVector){
		for(vector<mGeneVector*>::iterator itGeneVector = geneVector->begin();
				itGeneVector != geneVector->end();
				++itGeneVector){
			if(*itGeneVector){
				delete *itGeneVector;
				*itGeneVector = NULL;
			}
		}
		geneVector->clear();
		delete geneVector;
		geneVector = NULL;
	}
}


CString mGeneList::toString()
{
	if(daughter){
		return CString("GeneList of")+daughter->toString();
	}
	return "GeneList of NO daughter";
}

void mGeneList::selfLoad(istream &is)
{
	CString comment;
	is >> comment;
	mInt geneVectorNumber;
	is >> geneVectorNumber;
	for(mInt i=0;i < geneVectorNumber ; ++i){
		mGeneVector* newGeneVector = new mGeneVector(this);
		//̃CX^X̓fXgN^delete邱
		newGeneVector->selfLoad(is);
		geneVector->push_back(newGeneVector);
	}
	is >> comment;

}

void mGeneList::selfSave(ostream &os)
{
	os << "/*mGeneList start*/" <<endl;
	os << geneVector->size() <<endl;
	for(vector<mGeneVector*>::iterator itGeneVector = geneVector->begin();
			itGeneVector != geneVector->end();
			++itGeneVector){
		(*itGeneVector)->selfSave(os);
	}
	os << "/*mGeneList end*/" <<endl;

}

bool mGeneList::decideID(mGene *daughterGene, mID **newID, mGene **gene)
{
	*newID = NULL;
	*gene = NULL;
	for(vector<mGeneVector*>::iterator itGeneVector = geneVector->begin();
			itGeneVector != geneVector->end();
			++itGeneVector){
		if((*itGeneVector)->decideID(daughterGene,newID,gene)){
			return true; //Ƃ
		}
		if((*itGeneVector)->getSize() > daughterGene->getSize()){
			//TCY̏ɕł邽
			return false;
		}
	}
	return false; //ȂƂ
}

void mGeneList::addNewGene(mGene *daughterGene)
{
	const mInt daughterSize = daughterGene->getSize();
	for(vector<mGeneVector*>::iterator itGeneVector = geneVector->begin();
			itGeneVector != geneVector->end();
			++itGeneVector){
		if((*itGeneVector)->getSize() == daughterSize){
			//܂łȂāATCY炱ɓ
			(*itGeneVector)->addNewGene(daughterGene);
			return;
		}
		//geneVector̒g̓TCYŏɂĂ
		if((*itGeneVector)->getSize() > daughterSize){
			//TCY傫̂̂
			//̒OɓĂ
			break;
		}
	}
	//܂ł̃TCYɂ͂Ȃ
	mGeneVector* newGeneVector = new mGeneVector(this,daughterSize);
			//̃CX^X͂̃\bhdeleteȂ
	newGeneVector->addNewGene(daughterGene);
	geneVector->insert(itGeneVector,newGeneVector);
}

mGene* mGeneList::getGene(mID *ID)
{
	if(ID==NULL){
		//IDȂ猈߂Ȃ
		return NULL;
	}
	mInt daughterSize = ID->getSize();
	for(vector<mGeneVector*>::iterator itGeneVector = geneVector->begin();
			itGeneVector != geneVector->end();
			++itGeneVector){
		if((*itGeneVector)->getSize() == daughterSize){
			//܂łȂāATCY炱ōl
			//sNULLԂ
			return (*itGeneVector)->getGene(ID);
			
		}
		//geneVector̒g̓TCYŏɂĂ
		if((*itGeneVector)->getSize() > daughterSize){
			//TCY傫̂̂
			//TɎs
			return NULL;
		}
	}
	//TɎs
	return NULL;
}

void mGeneList::deleteSeed(mSeed *seed, mGene *gene)
{
	//̃\bhseeddeleteȂ
	//genemGeneVector̕delete邱
	if(seed==NULL){
		return;
	}
	const mInt daughterSize = gene->getSize();
	gene->deleteSeed(seed);
		//ŃW[ƃV[h͐؂藣ꂽ͂
	if(gene->getSeedNumber()!=0){
		return;
	}
	//geneɂ񂵂ĂseedȂȂgene
	for(vector<mGeneVector*>::iterator itGeneVector = geneVector->begin();
			itGeneVector != geneVector->end();
			++itGeneVector){
		if((*itGeneVector)->getSize() == daughterSize){
			//܂łȂāATCY炱ōl
			//sNULLԂ
			(*itGeneVector)->deleteGene(gene);
				//genedeleteĂ
			if((*itGeneVector)->getGeneNumber()==0){
				delete *itGeneVector;
				geneVector->erase(itGeneVector);
				//ۂɂȂ̂geneVectordelete
			}
			return;
		}
		//geneVector̒g̓TCYŏɂĂ
		if((*itGeneVector)->getSize() > daughterSize){
			//TCY傫̂̂
			//TɎs
			return;
		}
	}
	//TɎs
	return;
}

mID* mGeneList::makeNewID(mInt size)
{
	int testTime = daughter->getCurrentTime();
	mID* newID = new mID(size,daughter->getCurrentTime(),daughter->getIs1st());
	return newID;
}

mInt mGeneList::getGeneNumber()
{
	mInt returnValue = 0; 
	for(vector<mGeneVector*>::iterator itGeneVector = geneVector->begin();
			itGeneVector != geneVector->end();
			++itGeneVector){
		returnValue+=(*itGeneVector)->getGeneNumber();
	}
	return returnValue;
}

vector<mInt> mGeneList::getSizesList()
{
	vector<mInt> returnVector;
	for(vector<mGeneVector*>::iterator itGeneVector = geneVector->begin();
			itGeneVector != geneVector->end();
			++itGeneVector){
		returnVector.push_back((*itGeneVector)->getSize());
	}
	return returnVector;
}

vector<mSeed*> mGeneList::getSeedsList(mInt size)
{
	vector<mSeed*> returnVector;
	for(vector<mGeneVector*>::iterator itGeneVector = geneVector->begin();
			itGeneVector != geneVector->end();
			++itGeneVector){
		if((*itGeneVector)->getSize() == size){
			(*itGeneVector)->getSeedsList(&returnVector);
			return returnVector;
		}
		//geneVector̒g̓TCYŏɂĂ
		if((*itGeneVector)->getSize() > size){
			//TCY傫̂̂
			//TɎs
			return returnVector;
		}
	}
	//TɎs
	return returnVector;
}

vector<mGeneList::mGeneFreq*> mGeneList::getGeneFreqList()
{
	vector<mGeneFreq*> returnVector;
	for(vector<mGeneVector*>::iterator itGeneVector = geneVector->begin();
			itGeneVector != geneVector->end();
			++itGeneVector){
		if(*itGeneVector){
			vector<mGene*>* genes = (*itGeneVector)->getGenes();
			if(genes){
				for(vector<mGene*>::iterator itGene = genes->begin();
						itGene != genes->end();
						++itGene){
					if(*itGene == NULL){
						continue;
					}
					mGeneFreq* geneFreq = NULL;
					geneFreq = new mGeneFreq;
					//kSizeViewŉ邱
					geneFreq->IDString = (*itGene)->getID()->toString();
					geneFreq->freq = (*itGene)->getSeedNumber();
					geneFreq->gene = (*itGene);
					returnVector.push_back(geneFreq);
				} //end of for
			} //end of inner if
		} // end of outer if
	}
	return returnVector;
}

vector<mGeneList::mSizeFreq*> mGeneList::getSizeFreqList()
{
	vector<mSizeFreq*> returnVector;
	for(vector<mGeneVector*>::iterator itGeneVector = geneVector->begin();
			itGeneVector != geneVector->end();
			++itGeneVector){
		if(*itGeneVector){
			mSizeFreq* sizeFreq = new mSizeFreq;
					//kSizeViewŉ邱
			sizeFreq->size = (*itGeneVector)->getSize();
			sizeFreq->freq = (*itGeneVector)->getSeedNumber();
			returnVector.push_back(sizeFreq);
		}
	}
	return returnVector;
}

bool mGeneList::smallerThan(mGeneList::mSizeFreq* mine,mGeneList::mSizeFreq* yours)
{
	if(mine == NULL || yours == NULL){
		return false;
	}
	if(mine->size < yours->size){
		return true;
	}
	return false;
}

bool mGeneList::moreThanSize(mGeneList::mSizeFreq* mine,mGeneList::mSizeFreq* yours)
{
	if(mine == NULL || yours == NULL){
		return false;
	}
	if(mine->freq > yours->freq){
		return true;
	}
	if((mine->freq == yours->freq) && (mine->size < yours->size)){
		return true;
	}
	return false;
}

bool mGeneList::moreThanGene(mGeneList::mGeneFreq* mine,mGeneList::mGeneFreq* yours)
{
	if(mine == NULL || yours == NULL){
		return false;
	}
	if(mine->freq > yours->freq){
		return true;
	}
	if(mine->freq == yours->freq){
		if(mID::lessThan(mine->gene->getID(),yours->gene->getID())){
			return true;
		}
	}
	return false;
}

mGeneVector* mGeneList::getGeneVector(mInt size)
{
	if(geneVector == NULL){
		return NULL;
	}
	if(geneVector->size()==0){
		return NULL;
	}
	for(vector<mGeneVector*>::iterator itGeneVector = geneVector->begin();
			itGeneVector != geneVector->end();
			++itGeneVector){
		if(*itGeneVector){
			if((*itGeneVector)->getSize()==size){
				return *itGeneVector;
			}
			if((*itGeneVector)->getSize() > size){
				return NULL;
				//Ƀ\[gĂ邽
			}
		} // end of out if
	} //end of out for
	return NULL;
}
