// mGeneList.h: mGeneList NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MGENELIST_H__A1BC4001_12B0_11D4_A00F_F9ACF7FA0833__INCLUDED_)
#define AFX_MGENELIST_H__A1BC4001_12B0_11D4_A00F_F9ACF7FA0833__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Ion.h"
#include "mSuperClass.h"
#include "mDaughter.h"
class mDaughter;
#include "mGene.h"
class mGene;
#include "mID.h"
class mID;
#include "mSeed.h"
class mSeed;
#include "mGeneVector.h"
#include "mParameter.h"	// ClassView ɂĒǉ܂B
class mGeneVector;

//W[ŜǗNX
class mGeneList : public mSuperClass  
{
	class mSizeFreq
	{
	public:
		mInt size;
		mInt freq;
	};
	class mGeneFreq
	{
	public:
		CString IDString;
		mInt freq;
		mGene* gene;
	};
public:
	mGeneVector* getGeneVector(mInt size);
	static bool smallerThan(mSizeFreq* mine,mSizeFreq* yours);
	static bool moreThanSize(mSizeFreq* mine,mSizeFreq* yours);
	static bool moreThanGene(mGeneFreq* mine,mGeneFreq* yours);

	vector<mGeneFreq*> getGeneFreqList();
	vector<mSizeFreq*> getSizeFreqList();
	vector<mSeed*> getSeedsList(mInt size);
	vector<mInt> getSizesList();
	mInt getGeneNumber();
	mID* makeNewID(mInt size); //VID쐬
	void deleteSeed(mSeed* seed,mGene* gene); //XgV[h폜
	mGene* getGene(mID* ID); //ID݂̂ŃW[肷(mSeedselfLoad̋@\̂߁j
	void addNewGene(mGene* daughterGene); //ṼW[o^
	bool decideID(mGene* daughterGene,mID** newID,mGene** gene); //VłdaughterGeneṼW[ǂ𔻒f
	void selfSave(ostream& os);
	void selfLoad(istream& is);
	CString toString();
	mGeneList(mDaughter* daughter);
	virtual ~mGeneList();
private:
	vector<mGeneVector*>* geneVector;
	mDaughter* daughter; //daughterւ̃|C^
};

#endif // !defined(AFX_MGENELIST_H__A1BC4001_12B0_11D4_A00F_F9ACF7FA0833__INCLUDED_)
