// mGeneVector.h: mGeneVector NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MGENEVECTOR_H__F5CE7B80_19D7_11D4_B85A_00C04F87D0A5__INCLUDED_)
#define AFX_MGENEVECTOR_H__F5CE7B80_19D7_11D4_B85A_00C04F87D0A5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Ion.h"
#include "mSuperClass.h"
#include "mGene.h"
class mGene;
#include "mGeneList.h"
class mGeneList;
#include "mParameter.h"	// ClassView ɂĒǉ܂B

//TCYƃW[Ƃ𓯎Ɉ߂̃NX
class mGeneVector : public mSuperClass  
{
public:
	vector<mGene*>* getGenes();
	int getSeedNumber();
	void getSeedsList(vector<mSeed*>* seedList);
	void deleteGene(mGene* oldGene); //QƂ̂Ȃgene폜
	mGene* getGene(mID* ID); //IDGene߂
	mInt getSize();
	void addNewGene(mGene* newGene); //VW[o^
	bool decideID(mGene* daughterGene,mID** newID,mGene** gene); //VłdaughterGeneṼW[ǂ𔻒f
	mInt getGeneNumber();
	void selfLoad(istream& is);
	void selfSave(ostream& os);
	mGeneVector(mGeneList* geneList,mInt size); //VƋNp
	mGeneVector(mGeneList* geneList); //selfLoadp
	virtual  ~mGeneVector();

private:
	mGeneList* geneList; //W[Xgւ̃|C^
	mInt size; //WĂW[̃TCY
	vector<mGene*>* genes; //WĂW[̃Xg


};

#endif // !defined(AFX_MGENEVECTOR_H__F5CE7B80_19D7_11D4_B85A_00C04F87D0A5__INCLUDED_)
