// mInitialize.cpp: mInitialize NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Ion.h"
#include "mInitialize.h"
#include <direct.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//p[^[
const CString mInitialize::pathName = "original_log"; //Ƃ肠̃Ot@CpfBNg
const mDouble mInitialize::initialEnergy = 1000.0; //ŏ̃V[h̃GlM[

const mDouble mInitialize::initial_x     = 0.0; //ŏ̃V[h x W
const mDouble mInitialize::initial_y     = 0.0; //ŏ̃V[h y W

const mInt mInitialize::initial_code[] = {
	//ŏ̃V[h R[h
	set_leaf_energy,
	zero,
	inc,
	shl,
	shl,
	gsep,
	shl,
	shl,
	set_flower_energy,
	zero,
	inc,
	shl, //2
	shl, //4
	shl, //8
	shl, //16
	shl, //32
	gsep,
	shl, //64
	shl, //128
	shl, //256
	shl, //512
	set_r,
	zero,
	inc,
	shl,
	shl,
	shl,
	gsep,
	make_node,
	set_node_number,
	inc,
	gsep,
	set_theta,
	inc,
	shl,
	gsep,
	make_leaf,
	gsep,
	set_leaf_number,
	grow_leaf,
	grow_leaf,
	gsep,
	set_phy,
	inc,
	shl,
	inc,
	shl,
	gsep,
	make_flower,
	gsep,
	nop_1,
	nop_1,
	set_flower_number,
	grow_flower,
	grow_flower,
	breed_flower,
	gsep,
	jump_back,
	nop_0,
	nop_0,
	gsep
};

const mInt mInitialize::initial_size
	= sizeof(mInitialize::initial_code) / sizeof(mInitialize::initial_code[0]);	 
	//ŏ̃V[h TCY

mInitialize::mInitialize(mDaughter* daughter)
{
	//ňCɏĂ܂
	mGeneList* geneList = daughter->getGeneList();
	mID* daughterGeneID = geneList->makeNewID(initial_size);
	mGene* daughterGene = mGene::initialGene(geneList,initial_size,initial_code);
	daughterGene->setID(daughterGeneID);
	geneList->addNewGene(daughterGene);

	mPoint3D* newPoint3D = new mPoint3D(initial_x,initial_y,0.0); //ŏ̃V[h̓_
	mID* daughterSeedID = geneList->makeNewID(initial_size);
	mSeedList* seedList = daughter->getSeedList();
	mSeed* daughterSeed = new mSeed(
		daughterGene,seedList,
		daughterSeedID,newPoint3D,false,initialEnergy);
	seedList->addSpecialSeed(daughterSeed);

	CString makePathName = ((CIonApp*)AfxGetApp())->getExecutePath()+ pathName + '\\';
	_mkdir(makePathName.operator LPCTSTR());
	//̃fBNgɂ낢ƏނƂɂȂ͂B
	((CIonApp*)AfxGetApp())->setPathName(makePathName);

	ofstream os(((CIonApp*)AfxGetApp())->getPathName() + "Ion.ion");
	os << "this is target file" << endl;
	os.close();

	makeInitialGene();
	clearLog();
}

void mInitialize::clearLog()
{
	clearLog("c_time.log"); //݂܂ł̎s

	clearLog("edge.log"); //}ɎgGlM[
	clearLog("leaf.log"); //tɎgGlM[
	clearLog("flower.log"); //ԂɎgGlM[
	clearLog("per_edge.log"); //}ɎgGlM[̃p[Zg
	clearLog("per_leaf.log"); //tɎgGlM[̃p[Zg
	clearLog("per_flower.log"); //ԂɎgGlM[̃p[Zg

	clearLog("seed_num.log"); //V[h̐
	clearLog("gene_num.log"); //`q̐
	clearLog("ave_eva.log"); //ϕ]l
	clearLog("ave_size.log");//σTCY
	clearLog("ave_turn.log");//σ^[
	clearLog("ave_ene.log"); //σJgGlM[
	clearLog("cur_bir.log"); //݂̒a
	clearLog("cur_dea.log"); //݂̎Ő
	clearLog("fie_cap.log");//tB[h̃LpVeB[
	clearLog("birth.log"); //a
	clearLog("death.log"); //Ő

	clearLog("tot_ene.log"); //݂܂ł̑GlM[
	clearLog("tot_edge.log"); //}ɎgGlM[̑S
	clearLog("tot_leaf.log"); //tɎgGlM[̑S
	clearLog("tot_flow.log"); //ԂɎgGlM[̑S
	clearLog("tot_get.log"); //݂܂ł̂ꂽGlM[
	clearLog("tot_used.log"); //݂܂łɎgpGlM[
	clearLog("tot_keep.log"); //ȈێɎgpGlM[

	clearLog("ave_get.log"); //ꂽGlM[̕ϒl
	clearLog("ave_used.log"); //gpGlM[̕ϒl
	clearLog("ave_keep.log"); //ȈێGlM[̕ϒl

	clearLog("ope_ene.log"); //Iy[^Ƃ̃GlM[

	clearLog("log_turn.log"); //O^[ł̃O
}

void mInitialize::clearLog(const CString &filename)
{
	//t@C̒g̏
	CString filenameIn = ((CIonApp*)AfxGetApp())->getPathName() + filename;
	ofstream os(filenameIn);
	os.close();

}

mInitialize::~mInitialize()
{

}

static ostream& operator<<(ostream& os,CString str)
{
	os<<str.operator LPCTSTR();
	return os;
}


void mInitialize::makeInitialGene()
{
	//ŏԂ̈`q̐ݒt@C쐬
	ofstream os(((CIonApp*)AfxGetApp())->getPathName() + "gene.gini");
	os << "/* this is initial gene file */" << endl;

	os << pathName << " pathName //Ƃ肠̃Ot@CpfBNg" << endl;
	
	os << initialEnergy << " initialEnergy //ŏ̃V[h̃GlM[" << endl;

	os << initial_x << " initial_x //ŏ̃V[h x W" << endl;
	os << initial_y << " initial_y //ŏ̃V[h y W" << endl;

	os <<"/----code---size::"<<initial_size<<"----/"<<endl;
	for(mInt i = 0 ; i < initial_size ; ++i){
		os << mCPU::OperatorName[initial_code[i]] <<endl;
	}
	os << endl;
	os.close();
	
}

mInitialize::mInitialize(mDaughter *daughter, CString filename)
{	
	ifstream is(filename);
	CString readString;

	readString = readFromFile(is);
	CString path = readString.Left(readString.Find(' '));
	CString makePathName = ((CIonApp*)AfxGetApp())->getExecutePath()+ path + '\\';
	_mkdir(makePathName.operator LPCTSTR());
	//̃fBNgɂ낢ƏނƂɂȂ͂B
	((CIonApp*)AfxGetApp())->setPathName(makePathName);

	while(readGene(is,daughter)){
		//ł܂ǂݍ߂͂
	}

	is.close(); //Ńt@C̓ǂݍݏI


	
	ofstream os(((CIonApp*)AfxGetApp())->getPathName() + "Ion.ion");
	os << "this is target file" << endl;
	os.close();

	clearLog();

}

CString mInitialize::readFromFile(istream &is)
{
	const char COMMENT_START = '/';
	
	CString readString;

	do{
		is >> readString;
	}while(is.good() && (readString.GetLength() == 0 || readString.GetAt(0) == COMMENT_START));
		//̍sRgn܂s͓ǂݔ΂
	if(is.fail()){
		return ""; //sԂ
	}
	return readString;
}

bool mInitialize::readGene(istream &is, mDaughter *daughter)
{
	mDouble m_initialEnergy = initialEnergy;
	mDouble m_initial_x = initial_x;
	mDouble m_initial_y = initial_y;

	CString readString;
	CString codeString; //readString ̍ŏ̃Xy[X܂

	vector<mInt> codeArray;
	while(true){
		readString = readFromFile(is);
		int index = readString.Find(' ');
		if(index > 0){
			codeString = readString.Left(index);
		}else{
			codeString = readString;
		}
		if(readString.Compare("") == 0
				|| readString.Compare("next") == 0
				|| codeString.Compare("next") == 0){
			break;
		}
		if(readString.Find("initialEnergy") != -1){
			sscanf(readString.operator LPCTSTR(),"%lf",&m_initialEnergy);
		}else if(readString.Find("initial_x") != -1){
			sscanf(readString.operator LPCTSTR(),"%lf",&m_initial_x);
		}else if(readString.Find("initial_y") != -1){
			sscanf(readString.operator LPCTSTR(),"%lf",&m_initial_y);
		}else{
			for(mInt i = 0;i < mCPU::OperatorNumber; ++i){
				if(codeString.Compare(mCPU::ShortOperatorName[i]) == 0 
						|| codeString.Compare(mCPU::LongOperatorName[i]) == 0
						|| codeString.Compare(mCPU::OperatorName[i]) == 0){
					codeArray.push_back(i);
					break;
				}
			} //end of for
		} //end of if
	} //end of while
	mInt m_initial_size = codeArray.size();
	if(m_initial_size == 0){
		if(readString.Compare("next")==0
				|| codeString.Compare("next") == 0){
			return true; //܂
		}else{
			return false; //Ńt@C̓ǂݍݏI
		}
	}
	mInt* m_initial_code = new mInt[m_initial_size];
	mInt i = 0;
	for(vector<mInt>::iterator itMInt = codeArray.begin();
			itMInt != codeArray.end();
			++itMInt,++i){
		m_initial_code[i] = (*itMInt);
	}

	mGeneList* geneList = daughter->getGeneList();
	mID* daughterGeneID = geneList->makeNewID(m_initial_size);
	mGene* daughterGene = mGene::initialGene(geneList,m_initial_size,m_initial_code);

	delete[] m_initial_code;

	daughterGene->setID(daughterGeneID);
	geneList->addNewGene(daughterGene);

	mPoint3D* newPoint3D = new mPoint3D(m_initial_x,m_initial_y,0.0); //ŏ̃V[h̓_
	mID* daughterSeedID = geneList->makeNewID(m_initial_size);
	mSeedList* seedList = daughter->getSeedList();
	mSeed* daughterSeed = new mSeed(
		daughterGene,seedList,
		daughterSeedID,newPoint3D,false,m_initialEnergy);
	seedList->addSpecialSeed(daughterSeed);
	daughter->incrementCurrentTime() ; //IDborn_timeω邽
	if(readString.Compare("next")==0
			|| codeString.Compare("next")==0 ){
		return true; //܂
	}else{
		return false; //Ńt@C̓ǂݍݏI
	}
}
