// mParameter.cpp: mParameter NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Ion.h"
#include "mParameter.h"
#include <iomanip>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

mParameter::mParameter()
{

}

mParameter::~mParameter()
{

}

istream& operator>>(istream& is,CString& str)
{
	const int BUFFER_SIZE = 40; //悭gRg1s炢Ƃ̂悭Ȃ͂
	char buf[BUFFER_SIZE];
	char sep = '\n';
	int cur_len = 0;
	char* cur_string=NULL;
	char* new_string=NULL;
	is >> ws;
	while(is.peek() != sep && !(is.eof())){
		is.get(buf,BUFFER_SIZE,sep);
		cur_len=cur_len+strlen(buf);
		new_string=new char[cur_len+1];
		if(cur_string){
			strcpy(new_string,cur_string);
			delete[] cur_string;
		}else{
			*new_string='\0';
		}
		strcat(new_string,buf);
		cur_string=new_string;
	}
	is.get();
	str=cur_string;
	if(new_string){
		delete new_string;
	}
	return is;
}


ostream& operator<<(ostream& os,CString& str)
{
	os<<str.operator LPCTSTR();
	return os;
}

CString mParameter::parameterFileName = "parameter.pini";

/*-------------------------------------------*/

void mParameter::selfSave(CString pathName)
{
	ofstream os(pathName+parameterFileName);
	const int print_size=10;
	CString comment = "//----------------------------//" ;
	os << setprecision(print_size); 

	os << "/*-----------parameter.txt-----------*/" << endl;

	os << mDaughter_log_turn<<  " mDaughter_log_turn //d_IɃO邽߂̃^[" << endl;
	os << mField_daylight << " mField_daylight //ЂƂ̊iqɗ^GlM[" << endl;
	os << mEdge_keep_calorie <<" mEdge_keep_calorie //}̒PʃJ[̈ێJ[" <<endl;
	os << mLeaf_keep_calorie << " mLeaf_keep_calorie //t̒PʃJ[̈ێJ[" <<endl;
	os << mFlower_keep_calorie <<" mFlower_keep_calorie //Ԃ̒PʃJ[̈ێJ[" << endl;

	os << comment << endl;

	os << mEdge_calorie <<" mEdge_calorie //}̒Pʑ̐ς̃J[" << endl;
	os << mEdge_radius <<" mEdge_radius //}̔a" << endl;

	os << mLeaf_calorie << " mLeaf_calorie //t̒Pʑ̐ς̃J[" <<endl;

	os << mFlower_calorie <<" mFlower_calorie //Ԃ̒Pʑ̐ς̃J[" <<endl;

	os << mSeed_calorie <<" mSeed_calorie //V[h̒Pʑ̐ς̃J[" <<endl;
	os << mSeed_keep_calorie <<" mSeed_keep_calorie//V[ḧێJ[" << endl;
	os << mSeed_volume <<" mSeed_volume //V[h̑̐" <<endl;

	os << comment << endl;

	os << mField_N << " mField_N //tB[h̊iq̐" <<endl;
	os << mField_min_x << " mField_min_x //tB[hx̍ŏl" << endl;
	os << mField_min_y << " mField_min_y //tB[hy̍ŏl" << endl;
	os << mField_haba  << " mField_haba //iq̕" << endl;
	os << mField_downsize << " mField_downsize //̗vfłǂꂾGlM[邩" << endl;
	os << mField_capacity << " mField_capacity //L̋el" << endl;
	
	os << comment << endl;

	os << mGene_vectorVariation << " mGene_vectorVariation //vectorx̓ˑRψ" <<endl;
	os << mGene_sizeVariation << " mGene_sizeVariation //sizex̓ˑRψ" << endl;
	os << mGene_operatorVariation << " mGene_operatorVariation //operator̓ˑRψ" << endl;
	os << mGene_operatorRandomVariation << " mGene_operatorRandomVariation //operator̃rbgɂȂˑRψ" << endl;

	os << comment << endl;

	os << mSeedList_delete_factorial << " mSeedList_delete_factorial //V[hXgςɂȂƂɍ폜Ƃ̊mɂẴp[^[iʂ̂ƍŉʂƂ̔䗦j"  << endl;
	os << mSeedList_random_delete_probability << " mSeedList_random_delete_probability //V[hXg̒Ń_ɏ̂̊" << endl;
	os << mSeedList_min_random_delete_number << " mSeedList_min_random_delete_number //V[hXg̒̃V[h̐𒴂烉_ɏƂN" << endl;

	os << comment << endl;

	os << mMother_makeSpecial << " mMother_makeSpecial //܂ꂽ΂̃V[hXyVɂȂ邩ǂ" << endl;

	os << mGene_maxFatherEffect << " mGene_maxFatherEffect //father̍ő^" << endl;

	os <<  mSeedList_maxFatherDistance << " mSeedList_maxFatherDistance //father܂ł̍ő勗2" << endl;
	os <<  mSeedList_min_r << " mSeedList_min_r //r@gpۂ̍ŏl" << endl;
	os << mPartsList_tolerance_energy << " mPartsList_tolerance_energy //ӖȃGlM[gp֎~邽߂̒licurrent enrgyƂ̒l̐ψȏ̒l̃GlM[͈xɎgȂj"<<endl;

	os << comment << endl;

	os <<  mSeed_initialEvaluationValue << " mSeed_initialEvaluationValue //V[ĥƂ肠̏]l(pȂ)" << endl;

	os << comment << endl;

	os <<   mCPU_adjust_hight << " mCPU_adjust_hight   // ̃V[h̔Ԕ͈͂̕ϒl肷v" << endl;
	os <<  mCPU_hight_variance << " mCPU_hight_variance // Ԕ͈͂̕U(ϒl|邱̒lVarianceɂȂ)" << endl;

	os << comment << endl;

	os <<   mCPU_adjust_phy << " mCPU_adjust_phy  //phỹWX^Ǝۂ̒lƂ̕ϊ" << endl;
	os <<  mCPU_adjust_theta << " mCPU_adjust_theta//thetãWX^Ǝۂ̒lƂ̕ϊ" << endl;

	os << comment << endl;

	os <<  mCPU_energy_base << " mCPU_energy_base //mCPU̖ߌQ̃GlM[gp̊{l" << endl;

	os <<  mCPU_energy_nop_0 << " mCPU_energy_nop_0 //nop_0̃GlM[" << endl;
	os <<  mCPU_energy_nop_1 << " mCPU_energy_nop_1 //nop_1̃GlM[" << endl;
	os <<  mCPU_energy_gene_separate  << " mCPU_energy_gene_separate //gene_separatẽGlM[" << endl;
	os <<  mCPU_energy_if_counter_zero << " mCPU_energy_if_counter_zero //if_counter_zerõGlM[" << endl;

	os <<  mCPU_energy_jump_forward << " mCPU_energy_jump_forward //jump_forward̃GlM[" << endl;
	os <<  mCPU_energy_jump_back << " mCPU_energy_jump_back //jump_back̃GlM[" << endl;
	os <<  mCPU_energy_call << " mCPU_energy_call //call̃GlM[" << endl;
	os <<  mCPU_energy_ret << " mCPU_energy_ret //ret̃GlM[" << endl;

	os <<  mCPU_energy_push << " mCPU_energy_push //push̃GlM[" << endl;
	os <<  mCPU_energy_pop << " mCPU_energy_pop //pop̃GlM[" << endl;
	os <<  mCPU_energy_shift_left << " mCPU_energy_shift_left //shift_left̃GlM[" << endl;
	os <<  mCPU_energy_shift_right << " mCPU_energy_shift_right //shift_right̃GlM[" << endl;

	os <<  mCPU_energy_increment << " mCPU_energy_increment //increment̃GlM[" << endl;
	os <<  mCPU_energy_decrement << " mCPU_energy_decrement //decrement̃GlM[" << endl;
	os <<   mCPU_energy_zero  << " mCPU_energy_zero //zerõGlM[" << endl;
	os <<  mCPU_energy_cut_edge << " mCPU_energy_cut_edge //cut_edgẽGlM[" << endl;

	os << mCPU_energy_set_flower_number << " mCPU_energy_set_flower_number //set_flower_number̃GlM[" << endl;
	os <<  mCPU_energy_set_leaf_number << " mCPU_energy_set_leaf_number //set_leaf_number̃GlM[" << endl;
	os << mCPU_energy_set_flower_energy  << " mCPU_energy_set_flower_energy //set_flower_energỹGlM[" << endl;
	os <<  mCPU_energy_set_leaf_energy << " mCPU_energy_set_leaf_energy //set_leaf_energỹGlM[" << endl;

	os << mCPU_energy_set_node_number  << " mCPU_energy_set_node_number //set_node_number̃GlM[" << endl;
	os << mCPU_energy_set_edge_number  << " mCPU_energy_set_edge_number //setedge_number̃GlM[" << endl;
	os <<  mCPU_energy_set_phy << " mCPU_energy_set_phy //set_phỹGlM[" << endl;
	os <<  mCPU_energy_set_theta << " mCPU_energy_set_theta //set_thetãGlM[" << endl;

	os <<  mCPU_energy_set_r << " mCPU_energy_set_r //set_r̃GlM[" << endl;
	os <<  mCPU_energy_set_counter << " mCPU_energy_set_counter //set_counter̃GlM[" << endl;
	os <<  mCPU_energy_make_flower << " mCPU_energy_make_flower //make_flower̃GlM[" << endl;
	os <<  mCPU_energy_make_leaf << " mCPU_energy_make_leaf //make_leaf̃GlM[" << endl;

	os <<  mCPU_energy_make_node << " mCPU_energy_make_node //make_nodẽGlM[" << endl;
	os <<  mCPU_energy_grow_flower << " mCPU_energy_grow_flower //grow_flower̃GlM[" << endl;
	os <<  mCPU_energy_grow_leaf << " mCPU_energy_grow_leaf //grow_leaf̃GlM[" << endl;
	os << mCPU_energy_breed_flower   << " mCPU_energy_breed_flower //breed_flower̃GlM[" << endl;

	os << comment << endl;

	os << mSeed_turn_effect   << " mSeed_turn_effect //]l߂Ƃturň" << endl;

	os.close();
}

void mParameter::selfLoad(CString pathName,bool isFileName)
{
	if(isFileName){
		ifstream is(pathName);
		selfLoadIn(is);
		is.close();
	}else{
		ifstream is(pathName+parameterFileName);
		selfLoadIn(is);
		is.close();
	}
}

void mParameter::setParameter(mInt *value, const char* parameterString, CString& target)
{
	if(target.Find(parameterString) != -1){
		sscanf(target.operator LPCTSTR(),"%d",value);
	}
}

void mParameter::setParameter(mDouble *value, const char* parameterString, CString& target)
{
	if(target.Find(parameterString) != -1){
		sscanf(target.operator LPCTSTR(),"%lf",value);
	}

}

void mParameter::selfLoadIn(istream &is)
{
	const char COMMENT_START = '/';

	CString readString;
	while(is.good()){
		is >> readString;
		if(is.fail()){
			break;
		}
		if(readString.GetLength()==0){
			continue;
		}
		if(readString.GetAt(0)==COMMENT_START){
			continue;
		}

		setParameter(&mEdge_calorie , "mEdge_calorie" ,readString);
		setParameter(&mEdge_keep_calorie , "mEdge_keep_calorie" , readString);
		setParameter(&mEdge_radius ,"mEdge_radius" , readString);

		setParameter(&mLeaf_calorie , "mLeaf_calorie" ,readString);
		setParameter(&mLeaf_keep_calorie , "mLeaf_keep_calorie",readString);

		setParameter(&mFlower_calorie ,"mFlower_calorie" ,readString);
		setParameter(&mFlower_keep_calorie ,"mFlower_keep_calorie" ,readString);

		setParameter(&mSeed_calorie ,"mSeed_calorie",readString);
		setParameter(&mSeed_keep_calorie ,"mSeed_keep_calorie" ,readString);
		setParameter(&mSeed_volume ,"mSeed_volume",readString);

		setParameter(&mField_N , "mField_N" ,readString);
		setParameter(&mField_min_x , "mField_min_x" ,readString);
		setParameter(&mField_min_y , "mField_min_y" ,readString);
		setParameter(&mField_haba  , "mField_haba" ,readString);
		setParameter(&mField_daylight , "mField_daylight" ,readString);
		setParameter(&mField_downsize , "mField_downsize" ,readString);
		setParameter(&mField_capacity , "mField_capacity" ,readString);
	
		setParameter(&mGene_vectorVariation , "mGene_vectorVariation" ,readString);
		setParameter(&mGene_sizeVariation , "mGene_sizeVariation" ,readString);
		setParameter(&mGene_operatorVariation , "mGene_operatorVariation" ,readString);
		setParameter(&mGene_operatorRandomVariation , "mGene_operatorRandomVariation" ,readString);

		setParameter(&mSeedList_delete_factorial , "mSeedList_delete_factorial"  ,readString);
		setParameter(&mSeedList_random_delete_probability , "mSeedList_random_delete_probability" ,readString);
		setParameter(&mSeedList_min_random_delete_number , "mSeedList_min_random_delete_number" ,readString);

		setParameter(&mMother_makeSpecial , "mMother_makeSpecial" ,readString);

		setParameter(&mGene_maxFatherEffect , "mGene_maxFatherEffect" ,readString);

		setParameter(&mSeedList_maxFatherDistance , "mSeedList_maxFatherDistance" ,readString);
		setParameter(&mSeedList_min_r , "mSeedList_min_r" ,readString);

		setParameter(&mSeed_initialEvaluationValue , "mSeed_initialEvaluationValue" ,readString);
		setParameter(&mPartsList_tolerance_energy , "mPartsList_tolerance_energy" ,readString);

		setParameter( &mCPU_adjust_hight , "mCPU_adjust_hight" ,readString);
		setParameter( &mCPU_hight_variance , "mCPU_hight_variance" ,readString);

		setParameter( &mCPU_adjust_phy , "mCPU_adjust_phy" ,readString);
		setParameter( &mCPU_adjust_theta , "mCPU_adjust_theta" ,readString);

		setParameter( &mCPU_energy_base , "mCPU_energy_base" ,readString);

		setParameter( &mCPU_energy_nop_0 , "mCPU_energy_nop_0" ,readString);
		setParameter( &mCPU_energy_nop_1 , "mCPU_energy_nop_1" ,readString);
		setParameter( &mCPU_energy_gene_separate  , "mCPU_energy_gene_separate" ,readString);
		setParameter( &mCPU_energy_if_counter_zero , "mCPU_energy_if_counter_zero" ,readString);

		setParameter( &mCPU_energy_jump_forward , "mCPU_energy_jump_forward" ,readString);
		setParameter( &mCPU_energy_jump_back , "mCPU_energy_jump_back" ,readString);
		setParameter( &mCPU_energy_call , "mCPU_energy_call" ,readString);
		setParameter( &mCPU_energy_ret , "mCPU_energy_ret" ,readString);

		setParameter( &mCPU_energy_push , "mCPU_energy_push" ,readString);
		setParameter( &mCPU_energy_pop , "mCPU_energy_pop" ,readString);
		setParameter( &mCPU_energy_shift_left , "mCPU_energy_shift_left" ,readString);
		setParameter( &mCPU_energy_shift_right , "mCPU_energy_shift_right" ,readString);

		setParameter( &mCPU_energy_increment , "mCPU_energy_increment" ,readString);
		setParameter( &mCPU_energy_decrement , "mCPU_energy_decrement" ,readString);
		setParameter( &mCPU_energy_zero  , "mCPU_energy_zero" ,readString);
		setParameter( &mCPU_energy_cut_edge , "mCPU_energy_cut_edge" ,readString);

		setParameter( &mCPU_energy_set_flower_number , "mCPU_energy_set_flower_number" ,readString);
		setParameter( &mCPU_energy_set_leaf_number , "mCPU_energy_set_leaf_number" ,readString);
		setParameter( &mCPU_energy_set_flower_energy  , "mCPU_energy_set_flower_energy" ,readString);
		setParameter( &mCPU_energy_set_leaf_energy , "mCPU_energy_set_leaf_energy" ,readString);

		setParameter( &mCPU_energy_set_node_number  , "mCPU_energy_set_node_number" ,readString);
		setParameter( &mCPU_energy_set_edge_number  , "mCPU_energy_set_edge_number" ,readString);
		setParameter( &mCPU_energy_set_phy , "mCPU_energy_set_phy" ,readString);
		setParameter( &mCPU_energy_set_theta , "mCPU_energy_set_theta" ,readString);

		setParameter( &mCPU_energy_set_r , "mCPU_energy_set_r" ,readString);
		setParameter( &mCPU_energy_set_counter , "mCPU_energy_set_counter" ,readString);
		setParameter( &mCPU_energy_make_flower , "mCPU_energy_make_flower" ,readString);
		setParameter( &mCPU_energy_make_leaf , "mCPU_energy_make_leaf" ,readString);

		setParameter( &mCPU_energy_make_node , "mCPU_energy_make_node" ,readString);
		setParameter( &mCPU_energy_grow_flower , "mCPU_energy_grow_flower" ,readString);
		setParameter( &mCPU_energy_grow_leaf , "mCPU_energy_grow_leaf" ,readString);
		setParameter( &mCPU_energy_breed_flower   , "mCPU_energy_breed_flower" ,readString);

		setParameter( &mSeed_turn_effect   , "mSeed_turn_effect" ,readString);
		setParameter( &mDaughter_log_turn  , "mDaughter_log_turn" ,readString);
	} // end of while
}

/*-------------------------------------------*/


mDouble mParameter::mFlower_calorie =     100.0 ; //Ԃ̒Pʑ̐ς̃J[
mDouble mParameter::mFlower_keep_calorie= 0.010; //Ԃ̒PʃJ[̈ێJ[

mDouble mParameter::mLeaf_calorie   =     1.0 ; //t̒Pʑ̐ς̃J[
mDouble mParameter::mLeaf_keep_calorie  = 1.00; //t̒PʃJ[̈ێJ[

mDouble mParameter::mEdge_radius    =     0.5; //}̔a
mDouble mParameter::mEdge_calorie   =     1.0 ; //}̒Pʑ̐ς̃J[
mDouble mParameter::mEdge_keep_calorie  = 2.0; //}̒PʃJ[̈ێJ[

mDouble mParameter::mSeed_volume    =     10.0 ; //V[h̑̐
mDouble mParameter::mSeed_calorie   =     1.0 ; //V[h̒Pʑ̐ς̃J[
mDouble mParameter::mSeed_keep_calorie =  1.0 ; //V[ḧێJ[

mDouble mParameter::mCPU_energy_base =    1.0; //mCPU̖ߌQ̃GlM[gp̊{l

mDouble mParameter::mCPU_energy_nop_0               = mParameter::mCPU_energy_base; //nop_0̃GlM[
mDouble mParameter::mCPU_energy_nop_1               = mParameter::mCPU_energy_base; //nop_1̃GlM[
mDouble mParameter::mCPU_energy_gene_separate       = mParameter::mCPU_energy_base; //gene_separatẽGlM[
mDouble mParameter::mCPU_energy_if_counter_zero     = mParameter::mCPU_energy_base; //if_counter_zerõGlM[

mDouble mParameter::mCPU_energy_jump_forward        = mParameter::mCPU_energy_base; //jump_forward̃GlM[
mDouble mParameter::mCPU_energy_jump_back           = mParameter::mCPU_energy_base; //jump_back̃GlM[
mDouble mParameter::mCPU_energy_call                = mParameter::mCPU_energy_base; //call̃GlM[
mDouble mParameter::mCPU_energy_ret                 = mParameter::mCPU_energy_base; //ret̃GlM[

mDouble mParameter::mCPU_energy_push                = mParameter::mCPU_energy_base; //push̃GlM[
mDouble mParameter::mCPU_energy_pop                 = mParameter::mCPU_energy_base; //pop̃GlM[
mDouble mParameter::mCPU_energy_shift_left          = mParameter::mCPU_energy_base; //shift_left̃GlM[
mDouble mParameter::mCPU_energy_shift_right         = mParameter::mCPU_energy_base; //shift_right̃GlM[

mDouble mParameter::mCPU_energy_increment           = mParameter::mCPU_energy_base; //increment̃GlM[
mDouble mParameter::mCPU_energy_decrement           = mParameter::mCPU_energy_base; //decrement̃GlM[
mDouble mParameter::mCPU_energy_zero                = mParameter::mCPU_energy_base; //zerõGlM[
mDouble mParameter::mCPU_energy_cut_edge            = mParameter::mCPU_energy_base; //cut_edgẽGlM[

mDouble mParameter::mCPU_energy_set_flower_number   = mParameter::mCPU_energy_base; //set_flower_number̃GlM[
mDouble mParameter::mCPU_energy_set_leaf_number     = mParameter::mCPU_energy_base; //set_leaf_number̃GlM[
mDouble mParameter::mCPU_energy_set_flower_energy   = mParameter::mCPU_energy_base; //set_flower_energỹGlM[
mDouble mParameter::mCPU_energy_set_leaf_energy     = mParameter::mCPU_energy_base; //set_leaf_energỹGlM[

mDouble mParameter::mCPU_energy_set_node_number     = mParameter::mCPU_energy_base; //set_node_number̃GlM[
mDouble mParameter::mCPU_energy_set_edge_number     = mParameter::mCPU_energy_base; //setedge_number̃GlM[
mDouble mParameter::mCPU_energy_set_phy             = mParameter::mCPU_energy_base; //set_phỹGlM[
mDouble mParameter::mCPU_energy_set_theta           = mParameter::mCPU_energy_base; //set_thetãGlM[

mDouble mParameter::mCPU_energy_set_r               = mParameter::mCPU_energy_base; //set_r̃GlM[
mDouble mParameter::mCPU_energy_set_counter         = mParameter::mCPU_energy_base; //set_counter̃GlM[
mDouble mParameter::mCPU_energy_make_flower         = mParameter::mCPU_energy_base; //make_flower̃GlM[
mDouble mParameter::mCPU_energy_make_leaf           = mParameter::mCPU_energy_base; //make_leaf̃GlM[

mDouble mParameter::mCPU_energy_make_node           = mParameter::mCPU_energy_base; //make_nodẽGlM[
mDouble mParameter::mCPU_energy_grow_flower         = mParameter::mCPU_energy_base; //grow_flower̃GlM[
mDouble mParameter::mCPU_energy_grow_leaf           = mParameter::mCPU_energy_base; //grow_leaf̃GlM[
mDouble mParameter::mCPU_energy_breed_flower        = mParameter::mCPU_energy_base; //breed_flower̃GlM[

mDouble mParameter::mCPU_adjust_phy      =   (atan(1.0)*4.0)/6.0 ;  //phỹWX^Ǝۂ̒lƂ̕ϊ
mDouble mParameter::mCPU_adjust_theta    =   (atan(1.0)*4.0)/6.0 ;  //thetãWX^Ǝۂ̒lƂ̕ϊ

mDouble mParameter::mCPU_adjust_hight             = 1.50; // ̃V[h̔Ԕ͈͂̕ϒl肷i݂̍Ƃ̒l̐ςϒlɂȂj
mDouble mParameter::mCPU_hight_variance           = 1.0; // Ԕ͈͂̕U(ϒl|邱̒lVarianceɂȂ)

mDouble mParameter::mSeed_initialEvaluationValue  = 1.0; //V[ĥƂ肠̏]l(pȂ)

mDouble mParameter::mSeedList_maxFatherDistance   = 10.0*10.0; //father܂ł̍ő勗2
mDouble mParameter::mSeedList_min_r               = 1.0e-3   ; //r gpۂ̍ŏl

mDouble mParameter::mPartsList_tolerance_energy   = 10.0;      //ӖȃGlM[gp֎~邽߂̒licurrent enrgyƂ̒l̐ψȏ̒l̃GlM[͈xɎgȂj"<<endl;

mDouble mParameter::mGene_maxFatherEffect         = 0.50 ; //father̍ő^

#if 1
mDouble mParameter::mGene_vectorVariation         = 0.020; //vectorx̓ˑRψ
mDouble mParameter::mGene_sizeVariation           = 0.020; //sizex̓ˑRψ
mDouble mParameter::mGene_operatorVariation       = 0.050; //operator̓ˑRψ
mDouble mParameter::mGene_operatorRandomVariation = 0.90;  //operator̃rbgɂȂˑRψ
#else //ˑRψقNȂ
mDouble mParameter::mGene_vectorVariation         = 0.000; //vectorx̓ˑRψ
mDouble mParameter::mGene_sizeVariation           = 0.000; //sizex̓ˑRψ
mDouble mParameter::mGene_operatorVariation       = 0.000; //operator̓ˑRψ
mDouble mParameter::mGene_operatorRandomVariation = 0.00; //operator̃rbgɂȂˑRψ
#endif

mInt    mParameter::mField_N           = 1000  ; //tB[h̊iq̐
mDouble mParameter::mField_min_x       = -40.0 ; //tB[hx̍ŏl
mDouble mParameter::mField_min_y       = -40.0 ; //tB[hy̍ŏl
mDouble mParameter::mField_haba        = 40.0/1000.0*2.0  ; //iq̕
mDouble mParameter::mField_daylight    = 0.10*0.90/0.70  ; //ЂƂ̊iqɗ^GlM[
mDouble mParameter::mField_downsize    = 0.70  ; //̗vfłǂꂾGlM[邩
mDouble mParameter::mField_capacity    = 0.50  ; //L̋el

mDouble mParameter::mMother_makeSpecial= 0.5 ; //܂ꂽ΂̃V[hXyVɂȂ邩ǂ

mDouble mParameter::mSeed_turn_effect  = 1.5   ; //]l߂Ƃturň

mInt mParameter::mDaughter_log_turn    = 10000; //Od_IɎ^[

mDouble mParameter::mSeedList_random_delete_probability  = 0.0030; //V[hXg̒Ń_ɏ̂̊
mInt mParameter::mSeedList_min_random_delete_number      = 100   ; //V[hXg̒̃V[h̐𒴂烉_ɏƂN
mDouble mParameter::mSeedList_delete_factorial           = 2.0   ; //V[hXgςɂȂƂɍ폜Ƃ̊mɂẴp[^[iʂ̂ƍŉʂƂ̔䗦j
