// mParameter.h: mParameter NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MPARAMETER_H__EEF932B8_0FF5_11D4_A00F_E8E260E42D33__INCLUDED_)
#define AFX_MPARAMETER_H__EEF932B8_0FF5_11D4_A00F_E8E260E42D33__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Ion.h"
#include "mSuperClass.h"

typedef int mInt;
typedef double mDouble;

//p[^[ݒ肷NX
class mParameter : public mSuperClass  
{
public:
	static CString parameterFileName;
	static void setParameter(mDouble* value,const char* parameterString,CString& target);
	static void setParameter(mInt* value,const char* parameterString,CString& target);
	static void selfLoadIn(istream& is);
	static void selfLoad(CString pathName,bool isFileName = false);
	static void selfSave(CString pathName);

	static mDouble mSeedList_delete_factorial; //V[hXgςɂȂƂɍ폜Ƃ̊mɂẴp[^[iʂ̂ƍŉʂƂ̔䗦j
	static mDouble mSeedList_random_delete_probability; //V[hXg̒Ń_ɏ̂̊
	static mInt mSeedList_min_random_delete_number; //V[hXg̒̃V[h̐𒴂烉_ɏƂN
	static mDouble mMother_makeSpecial; //܂ꂽ΂̃V[hXyVɂȂ邩ǂ

	static mInt mField_N; //tB[h̊iq̐
	static mDouble mField_min_x; //tB[hx̍ŏl
	static mDouble mField_min_y; //tB[hy̍ŏl
	static mDouble mField_haba; //iq̕
	static mDouble mField_daylight; //ЂƂ̊iqɗ^GlM[
	static mDouble mField_downsize; //̗vfłǂꂾGlM[邩
	static mDouble mField_capacity; //L̋el
	
	static mDouble mGene_vectorVariation; //vectorx̓ˑRψ
	static mDouble mGene_sizeVariation; //sizex̓ˑRψ
	static mDouble mGene_operatorVariation; //operator̓ˑRψ
	static mDouble mGene_operatorRandomVariation; //operator̃rbgɂȂˑRψ

	static mDouble mGene_maxFatherEffect; //father̍ő^

	static mDouble mSeedList_maxFatherDistance; //father܂ł̍ő勗2
	static mDouble mSeedList_min_r; //r gpۂ̍ŏl

	static mDouble mSeed_initialEvaluationValue; //V[ĥƂ肠̏]l(pȂ)
	static mDouble mPartsList_tolerance_energy; //ӖȃGlM[gp֎~邽߂̒licurrent enrgyƂ̒l̐ψȏ̒l̃GlM[͈xɎgȂj

	static mDouble mCPU_adjust_hight;   // ̃V[h̔Ԕ͈͂̕ϒl肷v
	static mDouble mCPU_hight_variance; // Ԕ͈͂̕U

	static mDouble mCPU_adjust_phy;  //phỹWX^Ǝۂ̒lƂ̕ϊ
	static mDouble mCPU_adjust_theta;//thetãWX^Ǝۂ̒lƂ̕ϊ

	static mDouble mCPU_energy_base; //mCPU̖ߌQ̃GlM[gp̊{l

	static mDouble mCPU_energy_nop_0; //nop_0̃GlM[
	static mDouble mCPU_energy_nop_1; //nop_1̃GlM[
	static mDouble mCPU_energy_gene_separate; //gene_separatẽGlM[
	static mDouble mCPU_energy_if_counter_zero; //if_counter_zerõGlM[

	static mDouble mCPU_energy_jump_forward; //jump_forward̃GlM[
	static mDouble mCPU_energy_jump_back; //jump_back̃GlM[
	static mDouble mCPU_energy_call; //call̃GlM[
	static mDouble mCPU_energy_ret; //ret̃GlM[

	static mDouble mCPU_energy_push; //push̃GlM[
	static mDouble mCPU_energy_pop; //pop̃GlM[
	static mDouble mCPU_energy_shift_left; //shift_left̃GlM[
	static mDouble mCPU_energy_shift_right; //shift_right̃GlM[

	static mDouble mCPU_energy_increment; //increment̃GlM[
	static mDouble mCPU_energy_decrement; //decrement̃GlM[
	static mDouble mCPU_energy_zero; //zerõGlM[
	static mDouble mCPU_energy_cut_edge; //cut_edgẽGlM[

	static mDouble mCPU_energy_set_flower_number; //set_flower_number̃GlM[
	static mDouble mCPU_energy_set_leaf_number; //set_leaf_number̃GlM[
	static mDouble mCPU_energy_set_flower_energy; //set_flower_energỹGlM[
	static mDouble mCPU_energy_set_leaf_energy; //set_leaf_energỹGlM[

	static mDouble mCPU_energy_set_node_number; //set_node_number̃GlM[
	static mDouble mCPU_energy_set_edge_number; //setedge_number̃GlM[
	static mDouble mCPU_energy_set_phy; //set_phỹGlM[
	static mDouble mCPU_energy_set_theta; //set_thetãGlM[

	static mDouble mCPU_energy_set_r; //set_r̃GlM[
	static mDouble mCPU_energy_set_counter; //set_counter̃GlM[
	static mDouble mCPU_energy_make_flower; //make_flower̃GlM[
	static mDouble mCPU_energy_make_leaf; //make_leaf̃GlM[

	static mDouble mCPU_energy_make_node; //make_nodẽGlM[
	static mDouble mCPU_energy_grow_flower; //grow_flower̃GlM[
	static mDouble mCPU_energy_grow_leaf; //grow_leaf̃GlM[
	static mDouble mCPU_energy_breed_flower; //breed_flower̃GlM[

	static mDouble mEdge_keep_calorie; //}̒PʃJ[̈ێJ[
	static mDouble mSeed_keep_calorie; //V[ḧێJ[
	static mDouble mLeaf_keep_calorie; //t̒PʃJ[̈ێJ[
	static mDouble mFlower_keep_calorie; //Ԃ̒PʃJ[̈ێJ[

	static mDouble mEdge_calorie; //}̒Pʑ̐ς̃J[
	static mDouble mSeed_calorie; //V[h̒Pʑ̐ς̃J[
	static mDouble mSeed_volume; //V[h̑̐
	static mDouble mLeaf_calorie; //t̒Pʑ̐ς̃J[
	static mDouble mFlower_calorie; //Ԃ̒Pʑ̐ς̃J[
	static mDouble mEdge_radius; //}̔a

	static mDouble mSeed_turn_effect; //]l߂Ƃturň
	static mInt mDaughter_log_turn; //Od_IɎ^[

	mParameter();
	virtual ~mParameter();

};

extern const mDouble PI; //~
istream& operator>>(istream& is,CString& str); //CStringistream̊Ԃ󂯎
ostream& operator<<(ostream& os,CString& str); //CStringostream̊Ԃ󂯎

#endif // !defined(AFX_MPARAMETER_H__EEF932B8_0FF5_11D4_A00F_E8E260E42D33__INCLUDED_)
