// mPartsList.h: mPartsList NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MPARTSLIST_H__2556F525_1187_11D4_A00F_A951D1466933__INCLUDED_)
#define AFX_MPARTSLIST_H__2556F525_1187_11D4_A00F_A951D1466933__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Ion.h"
#include "mSuperClass.h"
#include "mSeed.h"
class mSeed;
#include "mFlower.h"
class mFlower;
#include "mLeaf.h"
class mLeaf;
#include "mEdge.h"
class mEdge;
#include "mNode.h"
#include "mParameter.h"	// ClassView ɂĒǉ܂B
class mNode;


#define ERROR_CHECK 1 //rebuildƂɂƂƂ 1 ɂ

//V[h̐AƂĂ̏ԂXgƂĈێ邽߂̃NX
class mPartsList : public mSuperClass  
{
public:
	bool check_energy(mDouble energy);
	bool check_energy(mDouble r,mDouble energy);
	mDouble getKeepCalorie();
	mDouble getEdgeKeepCalorie();
	mDouble getLeafKeepCalorie();
	mDouble getFlowerKeepCalorie();
	void saveBirdView(ostream& os);
	CString getABuffer();
	mPartsList(mSeed* seed);
	void calculateAggregateFlowerEnergy(); //Ԃ̂قŏW߂GlM[̗ʂvZ
	void calculateAggregateEnergy(); //t̂قŏW߂GlM[̗ʂvZ
	mFlower* getFlower(mInt index); //indexŎw肳ꂽԍ̉Ԃ̃|C^𓾂
	mDouble aggregateFlowerEnergy(); //ԂɂĎWꂽGlM[̑a
	mDouble aggregateEnergy(); //tɂĎWꂽGlM[̑a
	mDouble getCalorie(); //݂̏Ԃێ邽߂ɕKvȃJ[
	mDouble getVolume(); //Ŝ̑̐ς𓾂
	mDouble getEdgeCalorie(); //}̃J[𓾂
	mDouble getLeafCalorie(); //t̃J[𓾂
	mDouble getFlowerCalorie(); //Ԃ̃J[𓾂
	mDouble getEdgeVolume(); //}̑̐ς𓾂
	mDouble getLeafVolume(); //t̑̐ς𓾂
	mDouble getFlowerVolume(); //Ԃ̑̐ς𓾂
	void rebuild(mPoint3D* centerPoint3D); //݂ABuffer烊Xgč\
	bool canMakeEdge(mPoint3D* otherCenterPoint3D,mPoint3D* otherEndPoint3D); //}ƂɂԂ邩ǂf
	bool canMakeBowl(mPoint3D* otherCenterPoint3D,mDouble radius); //ƂɂԂ邩ǂf
	bool zero_flower(mInt flowerNumber); //breed̉Ԃ̑傫0ɂ
	bool cut_edge(mInt edgeNumber); //}
	bool grow_leaf(mInt leafNumber,mDouble energy); //t傫
	bool grow_flower(mInt flowerNumber,mDouble energy); //Ԃ傫
	bool make_node(mInt nodeNumber,mDouble r,mDouble theta,mDouble phy); //m[h
	bool make_leaf(mInt nodeNumber,mDouble energy,mDouble r,mDouble theta,mDouble phy); //t
	bool make_flower(mInt nodeNumber,mDouble energy,mDouble r,mDouble theta,mDouble phy); //Ԃ
	void selfSave(ostream& os);
	void selfLoad(istream& is);
	CString toString();
	mPartsList(mSeed* seed,CString initalABuffer);
	virtual ~mPartsList();
	vector<mFlower*>* getFlowerList();//Ԃ̂߂̃Xg𓾂
	vector<mLeaf*>* getLeafList();//t̂߂̃Xg𓾂
	vector<mEdge*>* getEdgeList();//}̂߂̃Xg𓾂
	vector<mNode*>* getNodeList();//m[ĥ߂̃Xg𓾂

private:
	void cutStringRadius(const mInt index); //index '>'܂ł̕
	mInt countChar(const char targetChar,const mInt endIndex); //ABufferendIndex܂łtargetCharJ
	mInt searchIndex(const char targetChar,const mInt targetNumber); //ABuffertargetChartargetNumberԖڂǂ̃CfNbXׂ
	bool canMake(mPoint3D* otherCenterPoint3D,mPoint3D* otherEndPoint3D,mDouble radius=0.0); //canMakeEdgecanMakeBowl̓
	mDouble aggregateEnergyFlower; //Ԃ̂قŏW߂
	mDouble aggregateEnergyValue; //t̂قŏW߂
	mPoint3D* makePoint3D(mDouble r,mDouble theta,mDouble phy); //ɍWfJgW
	void freeList(); //Xg̉
	mSeed* seed; //V[hւ̃|C^
	CString ABuffer; //݂̐AƂĂ̏Ԃێ

	vector<mFlower*>* flowerList;//Ԃ̂߂̃Xg
	vector<mLeaf*>* leafList;//t̂߂̃Xg
	vector<mEdge*>* edgeList;//}̂߂̃Xg
	vector<mNode*>* nodeList;//m[ĥ߂̃Xg
};

#endif // !defined(AFX_MPARTSLIST_H__2556F525_1187_11D4_A00F_A951D1466933__INCLUDED_)
