// mSeed.h: mSeed NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MSEED_H__2556F520_1187_11D4_A00F_A951D1466933__INCLUDED_)
#define AFX_MSEED_H__2556F520_1187_11D4_A00F_A951D1466933__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Ion.h"
#include "mSuperClass.h"
#include "mCPU.h"
class mCPU;
#include "mEnergy.h"
class mEnergy;
#include "mPartsList.h"
class mPartsList;
#include "mGene.h"
class mGene;
#include "mSeedList.h"
class mSeedList;
#include "mPoint3D.h"
class mPoint3D;
#include "mID.h"
class mID;
#include "mParameter.h"	// ClassView ɂĒǉ܂B

//V[h\߂̃NX
class mSeed : public mSuperClass  
{
public:
	static bool IDSort(mSeed* mine,mSeed* yours);
	mInt getBreedNumber(); //񂾂̐\
	void changeGene(mGene* gene,mSeedList* seedList); //mMotherSeedChangegeneseedListςĂ܂
	static bool greaterThan(mSeed* mySeed,mSeed* yourSeed); //V[hm̕]lɂrs
	mDouble calculateEvaluationValue(); //̃V[h̕]lvZ
	void execute(); //CPUexecutes
	void setIsBirth(mInt Value); //isBirth̐ݒ
	mDouble getEvaluationValue(); //̃V[h̕]l𓾂(calculate邱)
	bool canMakeEdge(mPoint3D* otherCenterPoint3D,mPoint3D* otherEndPoint3D); //w肳ꂽƂɎ}邩ǂ̔f
	bool canMakeBowl(mPoint3D* centerPoint3D,mDouble radius); //w肳ꂽƂɋ邩ǂ̔f
	mInt getTurnNumber();
	mInt getIsBirth();
	mPoint3D* getCenterPoint3D();
	mPartsList* getPartsList();
	mCPU* getCPU();
	mID* getID();
	mGene* getGene();
	mSeedList* getSeedList();
	void selfSave(ostream& os);
	void selfLoad(istream& is);
	CString toString();
	mSeed(mSeedList* seedList); //selfLoad̂ƂɎg
	mSeed(mGene* gene,mSeedList* seedList,mID* ID,mPoint3D* centerPoint3D,mInt isBirth,mDouble initialEnergy); //breed̍ۂɎg
	virtual ~mSeed();

private:
	mDouble evaluationValue; //݂̕]l
	mInt turnNumber; //executeŝ
	mInt isBirth; //SeedList̒birthVector̗vfǂ
	mPoint3D* centerPoint3D; //S_
	mPartsList* partsList; //partsListւ̃|C^
	mCPU* CPU; //CPUւ̃|C^
	mID* ID; //IDւ̃|C^
	mGene* gene; //W[ւ̃|C^
	mSeedList* seedList; //V[hXgւ̃|C^
	mSeed(); //ftHgRXgN^͎gȂ
};

#endif // !defined(AFX_MSEED_H__2556F520_1187_11D4_A00F_A951D1466933__INCLUDED_)
