// mSeedList.cpp: mSeedList NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Ion.h"
#include "mSeedList.h"
#include <algorithm>
#include <math.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

mSeedList::mSeedList()
{
	//gȂ
}

mSeedList::mSeedList(mDaughter *daughter)
{
	this->daughter = daughter;
		//͂̃NXdeleteȂ
	seedVector = NULL;
	birthVector = NULL;
	specialVector = NULL;
		//ꉞ̕ی
	seedVector = new vector<mSeed*>;
	birthVector = new vector<mSeed*>;
	specialVector = new vector<mSeed*>;
		//3̃Xg͂̃NXdelete邱
	energy = new mEnergy;
		//delete邱
	seedPointer = seedVector->begin();
		//Ƃ肠̏
	m=0;
	currentBirthNumber = 0;
	currentDeathNumber = 0;
	birthNumber = 0;
	deathNumber = 0;
	averageEvaluationValue = mParameter::mSeed_initialEvaluationValue;
	averageTurnNumber = 0.0; //Ƃ肠_~[̏
	averageSize = 0.0;
}

mSeedList::~mSeedList()
{
	//Ђdelete
	vector<mSeed*>::iterator itSeed;
	if(seedVector){
		for(itSeed = seedVector->begin();
				itSeed != seedVector->end(); ++itSeed){
			delete *itSeed;
			*itSeed=NULL;
		}
		delete seedVector;
		seedVector = NULL;
	}
	if(birthVector){
		for(itSeed = birthVector->begin();
				itSeed != birthVector->end(); ++itSeed){
			delete *itSeed;
			*itSeed=NULL;
		}
		delete birthVector;
		birthVector = NULL;
	}
	if(specialVector){
		for(itSeed = specialVector->begin();
				itSeed != specialVector->end(); ++itSeed){
			delete *itSeed;
			*itSeed=NULL;
		}
		delete specialVector;
		specialVector = NULL;
	}
	if(energy){
		delete energy;
		energy=NULL;
	}
}


vector<mSeed*>* mSeedList::getSeedVector()
{
	return seedVector;
}

vector<mSeed*>* mSeedList::getBirthVector()
{
	return birthVector;
}

vector<mSeed*>* mSeedList::getSpecialVector()
{
	return specialVector;
}

CString mSeedList::toString()
{
	return CString("SeedList of ")+daughter->toString();
}

void mSeedList::selfLoad(istream &is)
{
	CString comment;
	is >> comment;
	is >> birthNumber 
		>> deathNumber 
		>> currentBirthNumber 
		>> currentDeathNumber 
		>> averageEvaluationValue
		>> averageTurnNumber
		>> averageSize
		>> m ;
	energy->selfLoad(is);
	//Ƃ̓Xg̕A
	mInt size;
	is >>size;
	for(mInt i=0;i<size;++i){
		mSeed* newSeed = new mSeed(this);
			//̃CX^X͂̃NX
			//fXgN^delete
		newSeed->selfLoad(is);
		seedVector->push_back(newSeed);
	}
	//seedPointer̒
	seedPointer = seedVector->begin() + m;
	is >>size;
	for(i=0;i<size;++i){
		mSeed* newSeed = new mSeed(this);
			//̃CX^X͂̃NX
			//fXgN^delete
		newSeed->selfLoad(is);
		birthVector->push_back(newSeed);
	}
	is >>size;
	for(i=0;i<size;++i){
		mSeed* newSeed = new mSeed(this);
			//̃CX^X͂̃NX
			//fXgN^delete
		newSeed->selfLoad(is);
		specialVector->push_back(newSeed);
	}
	is >> comment;
	calculateEnergy();
}

void mSeedList::selfSave(ostream &os)
{
	os << "/*mSeedList start*/" << endl;
	os << birthNumber << ' '
		<< deathNumber << ' '
		<< currentBirthNumber << ' '
		<< currentDeathNumber << ' '
		<< averageEvaluationValue <<' '
		<< averageTurnNumber <<' '
		<< averageSize <<' '
		<< m <<endl;
	energy->selfSave(os);
	//Ƃ̓Xg̕ۑ
	vector<mSeed*>::iterator itSeed;
	os << seedVector->size() <<endl;
	for(itSeed = seedVector->begin();
			itSeed != seedVector->end(); ++itSeed){
		(*itSeed)->selfSave(os);
	}
	os << birthVector->size() <<endl;
	for(itSeed = birthVector->begin();
			itSeed != birthVector->end(); ++itSeed){
		(*itSeed)->selfSave(os);
	}
	os << specialVector->size() <<endl;
	for(itSeed = specialVector->begin();
			itSeed != specialVector->end(); ++itSeed){
		(*itSeed)->selfSave(os);
	}
	os << "/*mSeedList end*/" << endl;
}

void mSeedList::init_execute()
{
	// execute ̏s
	m=0;
	seedPointer=seedVector->begin();
	currentBirthNumber=0;

}

void mSeedList::execute()
{
	if(isOverExceute()){
		//sׂȂ
		return;
	}
	(*seedPointer)->execute();
		//ۂɎs

	++m;
	++seedPointer;
		//̂ɐi߂Ă

}

void mSeedList::after_execute()
{
	currentDeathNumber=0;
	//executě㏈
	calculateEnergy();
		//܂̓GlM[
	SuperNova();
		//SuperNova
	birthProcess();
		//ŌbirthVector̐U蕪
	currentDeathNumber+=specialVector->size();
		//specialVector̒g͂l̂ɈڂĂ܂
	birthNumber += currentBirthNumber;
	deathNumber += currentDeathNumber;
}

void mSeedList::SuperNova()
{
	const mInt prevSize=seedVector->size();
		//폜ÕV[ȟ

	vector<mSeed*>::iterator itSeed;

	//]l̍ČvZ͂̑OɌĂ΂
	//calculateEnergyōsĂ̂
	//ڕ]lgƂł
	//]l̍~Ń\[g
	sort(seedVector->begin(),seedVector->end(),mSeed::greaterThan);

	if(daughter->getField()->capacityOver()){
		//I[o[Ă̂ō폜
		const mInt length = seedVector->size();
		const mInt eraseNumber=(mInt)((mDouble)length
			* daughter->getField()->adjustCapacity());
				//̐폜
/*		if(eraseNumber > 0){
			itSeed = seedVector->begin()
					+ seedVector->size() - eraseNumber ;
				//KvȂƂ܂Ői߂
		}else{
			itSeed = seedVector->end();
		}
		while(itSeed != seedVector->end()){
			daughter->getGeneList()
				->deleteSeed(*itSeed,(*itSeed)->getGene());
			delete *itSeed;
			*itSeed = NULL;
			seedVector->erase(itSeed);
		} //end of while 
*/
		const mDouble dlength = (mDouble)length;
		const mDouble factor = 2.0*((mDouble)eraseNumber)
			/ (dlength * dlength) / (dlength + 1.0);
		mInt index = 1; // 0łȂPł邱Ƃɒ
		const mDouble k = mParameter::mSeedList_delete_factorial;
		mDouble value = 2.0/(dlength*(k+1.0));
		const mDouble step = value*(k-1.0)/(dlength-1.0);
		for(itSeed = seedVector->begin();
				itSeed != seedVector->end();
				++index , value += step){
					mDouble c = mSimpleRandom::getmValue();
			if(c < value){
				daughter->getGeneList()
					->deleteSeed(*itSeed,(*itSeed)->getGene());
				delete *itSeed;
				*itSeed = NULL;
				seedVector->erase(itSeed);
			}else{
				++itSeed;
			}
		}

	} //end of if (eraceNumber > 0)

	//]l0ȉ̂̂폜
	for(itSeed = seedVector->begin();
			itSeed != seedVector->end();
			++itSeed){
		//KvȂƂ܂Ői߂
		if((*itSeed)->getEvaluationValue() <= 0.0){
				break;
		}
	}
	while(itSeed != seedVector->end()){
		daughter->getGeneList()
			->deleteSeed(*itSeed,(*itSeed)->getGene());
		delete *itSeed;
		*itSeed = NULL;
		seedVector->erase(itSeed);
	} //end of while 

	//̊mŃ_Ɏł
	if(seedVector->size() > mParameter::mSeedList_min_random_delete_number){
		for(itSeed = seedVector->begin();
		itSeed != seedVector->end();  ){
			if(mSimpleRandom::getmValue() < mParameter::mSeedList_random_delete_probability){
				daughter->getGeneList()
					->deleteSeed(*itSeed,(*itSeed)->getGene());
				delete *itSeed;
				*itSeed = NULL;
				seedVector->erase(itSeed);
			}else{
				++itSeed;
			}
		}
	}
	const int differ = prevSize - seedVector->size();
	currentDeathNumber += differ;
		//폜ꂽ̌L^Ă
}

void mSeedList::birthProcess()
{
	mMother* mother = daughter->getMother();
	vector<mSeed*>::iterator itSeed;

	for(itSeed = birthVector->begin();
			itSeed != birthVector->end();
			++itSeed){
		(*itSeed)->setIsBirth(false);
		if(mother->isSpecial()){
			//specialVector̕Ɏg
			specialVector->push_back(*itSeed);
		}else{
			//seedVector̕Ɏg
			seedVector->push_back(*itSeed);
		}
	}
	birthVector->clear();
		//birthVector͒gȂȂ͂
}

void mSeedList::addBirthSeed(mSeed *seed)
{
	//breedŐ܂ꂽo^Ă
	birthVector->push_back(seed);
	seed->getGene()->addNewSeed(seed);
	++currentBirthNumber;
		//܂ꂽ𒲐Ă
}

void mSeedList::addSpecialSeed(mSeed *seed)
{
	//ldaughter炫seed
	seedVector->push_back(seed);
	seed->getGene()->addNewSeed(seed);
	++currentBirthNumber;
		//܂ꂽ𒲐Ă

}

mGene* mSeedList::selectFather(mSeed *seed, mPoint3D *centerPoint3D, mDouble *per)
{
	mGene* fatherGene = seed->getGene();
			//Ȃ炱Ԃ
	//܂́uŒZŁvT
	mDouble minimum = HUGE_VAL; //݁[̏l
	mDouble effect = 0.0;
	vector<mSeed*>::iterator itSeed;
	vector<mFlower*>::iterator itFlower;
	vector<mFlower*>* flowerList;
	mPoint3D* flowerCenterPoint3D;
			//̃CX^XdeleteȂ
	for(itSeed = seedVector->begin();
			itSeed!=seedVector->end();
			++itSeed){
		if(*itSeed == seed){
			continue;
			//MotherFather͂ł邾ႤV[hł悤ɂ邽
		}
		flowerList = (*itSeed)->getPartsList()->getFlowerList();
		for(itFlower = flowerList->begin();
				itFlower != flowerList->end();
				++itFlower){
			flowerCenterPoint3D = (*itFlower)->getCenterPoint3D();
			mDouble distance2=mPoint3D::getDistanceSquare(flowerCenterPoint3D,centerPoint3D);
			if(distance2>mParameter::mSeedList_maxFatherDistance){
				//ꂷĂ̂ŎgȂ
				continue;
			}
			effect +=1.0/distance2; //ʂɋ𑫂Ă
			if(distance2<minimum){
				//ŏl̂̂ōXV
				minimum=distance2;
				fatherGene = (*itSeed)->getGene();
			}
		} //end of for ,itFlower

	} //end of for ,itSeed
	if(minimum == HUGE_VAL || effect != 0.0){
		//̂Q͓̏
		//*per͕êɑ΂^
		*per = 1.0/minimum/effect;
			//2̋̋t̊ŌvZ
	}else{
		*per = 0.0;
	}
	if(*per < 0.0){
		*per = 0.0;
	}else if(*per > 1.0){
		*per = 1.0;
	}
	return fatherGene;
}

void mSeedList::calculateEnergy()
{
	//ł̓GlM[̕ϒlȂǂ߂
	vector<mSeed*>::iterator itSeed;
	energy->initialEnergy(); //
	averageEvaluationValue = 0.0;
	averageTurnNumber = 0.0;
	averageSize = 0.0;
	for(itSeed = seedVector->begin();
			itSeed != seedVector->end();
			++itSeed){
		//ŕς߂̂vZ
		energy->addOtherEnergy((*itSeed)->getCPU()->getEnergy());
		//(*itSeed)->calculateEvaluationValue();
			//]l͎sɏĂ
		averageEvaluationValue += (*itSeed)->getEvaluationValue();
		averageTurnNumber += (*itSeed)->getTurnNumber();
		averageSize += (*itSeed)->getGene()->getSize();
	}
	mInt number = seedVector->size();
	energy->divideByNumber(number); //ϒl߂
	if(number > 0){
		averageEvaluationValue /= (mDouble)number;
		averageTurnNumber /= (mDouble)number;
		averageSize /= (mDouble)number;
	}
}

mInt mSeedList::getM()
{
	return m;
}

mInt mSeedList::getBirthNumber()
{
	return birthNumber;
}

mInt mSeedList::getDeathNumber()
{
	return deathNumber;
}

mInt mSeedList::getCurrentBirthNumber()
{
	return currentBirthNumber;
}

mInt mSeedList::getCurrentDeathNumber()
{
	return currentDeathNumber;
}

mEnergy* mSeedList::getEnergy()
{
	return energy;
}

mDaughter* mSeedList::getDaughter()
{
	return daughter;
}

bool mSeedList::canMakeBowl(mPoint3D *otherCenterPoint3D, mDouble radius)
{
	vector<mSeed*>::iterator itSeed;

	for(itSeed = seedVector->begin();
			itSeed != seedVector->end();
			++itSeed){
		if(!(*itSeed)->canMakeBowl(otherCenterPoint3D,radius)){
			//ƂイłԂĂ
			return false;
		}
	}
	return true; //邱Ƃł
}

bool mSeedList::canMakeEdge(mPoint3D *otherCenterPoint3D, mPoint3D *otherEndPoint3D)
{
	vector<mSeed*>::iterator itSeed;

	for(itSeed = seedVector->begin();
			itSeed != seedVector->end();
			++itSeed){
		if(!(*itSeed)->canMakeEdge(otherCenterPoint3D,otherEndPoint3D)){
			//ƂイłԂĂ
			return false;
		}
	}
	return true; //邱Ƃł
}

bool mSeedList::isOverExceute()
{
	//s郊XgŌɓBĂ
	if(m==seedVector->size() ||
			seedPointer==seedVector->end()){
		//2̏͊{Iɓł
		return true;
	}
	return false;
}

mDouble mSeedList::getAverageEvaluationValue()
{
	//calculateEnergy ̂ƂɍXV
	return averageEvaluationValue;
}

mDouble mSeedList::getAverageTurnNumber()
{
	//calculateEnergy ̂ƂɍXV
	return averageTurnNumber;
}

mDouble mSeedList::getAverageSize()
{
	return averageSize;
}

mSeed* mSeedList::getSeedPointer()
{
	if(seedVector==NULL){
		return NULL;
	}
	if(seedVector->size()==0){
		return NULL;
	}
	return *seedPointer;
}

mSeed* mSeedList::getSeedWithIDString(CString IDString)
{
	if(seedVector == NULL){
		return NULL;
	}
	if(seedVector->size()==0){
		return NULL;
	}
	vector<mSeed*>::iterator itSeed;
	for(itSeed = seedVector->begin();
			itSeed != seedVector->end();
			++itSeed){
				if(IDString.Compare((*itSeed)->getID()->toString())==0){
					return *itSeed;
				}
	}
	return NULL;
}

void mSeedList::saveBirdView(ostream &os)
{
	if(seedVector){
		for(vector<mSeed*>::iterator it = seedVector->begin();
				it != seedVector->end();
				++it){
			if(*it){
#if 0
				if((*it)->getPartsList()->getEdgeList()->size() <= 1){
				//}{ȉȂ\Ȃ
					continue;
				}

				if((*it)->getBreedNumber() == 0){
				//˂ȂȂ\Ȃ
					continue;
				}
#endif
				os <<(*it)->toString() <<endl;
				(*it)->getPartsList()->saveBirdView(os);
			}
		}
	}
}
