// mSeedList.h: mSeedList NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MSEEDLIST_H__136E5F24_1249_11D4_A00F_EB25FC123F33__INCLUDED_)
#define AFX_MSEEDLIST_H__136E5F24_1249_11D4_A00F_EB25FC123F33__INCLUDED_

#include "mParameter.h"	// ClassView ɂĒǉ܂B
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Ion.h"
#include "mSeed.h"
class mSeed;
#include "mEnergy.h"
class mEnergy;
#include "mDaughter.h"
class mDaughter;
#include "mPoint3D.h"
class mPoint3D;
#include "mGene.h"
class mGene;
#include "mSuperClass.h"

//V[hXgƂĊǗ邽߂̃NX
class mSeedList : public mSuperClass  
{
public:
	void saveBirdView(ostream& os);
	mSeed* getSeedWithIDString(CString IDString); //IDStringSeed肷
	mSeed* getSeedPointer();
	mDouble getAverageSize();
	mInt getM();
	bool isOverExceute();
	bool canMakeEdge(mPoint3D* otherCenterPoint3D,mPoint3D* otherEndPoint3D); //邩ǂ̔
	bool canMakeBowl(mPoint3D* otherCenterPoint3D,mDouble radius); //邩ǂ̔
	mDaughter* getDaughter();
	mEnergy* getEnergy();
	mDouble getAverageTurnNumber();
	mDouble getAverageEvaluationValue();
	mInt getCurrentDeathNumber();
	mInt getCurrentBirthNumber();
	mInt getDeathNumber();
	mInt getBirthNumber();
	void calculateEnergy(); //^[IɃGlM[vZ
	mGene* selectFather(mSeed* seed,mPoint3D* centerPoint3D,mDouble* per); //FatherƂȂW[ƁAMotherFather̔䗦(per)肷
	void addSpecialSeed(mSeed* seed); //ldaughter̃V[h
	void addBirthSeed(mSeed* seed);//a΂̃V[hbirthVectorɉ
	void after_execute(); //executě㏈
	void execute(); //execute{
	void init_execute(); //executȇO
	void selfSave(ostream& os);
	void selfLoad(istream& is);
	CString toString();
	mSeedList(mDaughter* daughter);
	vector<mSeed*>* getSeedVector();//V[h̃Xg{
	vector<mSeed*>* getBirthVector();//܂ꂽẴV[h
	vector<mSeed*>* getSpecialVector();//lDaughterɈڂ߂̃Xg
	virtual ~mSeedList();
private:
	void birthProcess(); //birthVector̐U蕪
	void SuperNova(); //SuperNovas
	mDaughter* daughter; //daughterւ̃|C^
	vector<mSeed*>::iterator seedPointer; //seddVector̂߂iterator
	mEnergy* energy; //GlM[Ǘ
	mDouble averageTurnNumber; //Õ^[̕σ^[
	mDouble averageSize; //Õ^[̕σTCY
	mDouble averageEvaluationValue; //Õ^[̕ϕ]l
	mInt currentDeathNumber; //Õ^[ł̎Ő
	mInt currentBirthNumber; //݂̃^[ł̒a
	mInt deathNumber; //݂܂ł̎Ő
	mInt birthNumber; //݂܂ł̒a
	mInt m; //ݎs̃V[hseedVector̉Ԗڂ
	vector<mSeed*>* seedVector;//V[h̃Xg{
	vector<mSeed*>* birthVector;//܂ꂽẴV[h
	vector<mSeed*>* specialVector;//lDaughterɈڂ߂̃Xg
	mSeedList();//ftHgRXgN^͎gȂ
};

#endif // !defined(AFX_MSEEDLIST_H__136E5F24_1249_11D4_A00F_EB25FC123F33__INCLUDED_)
