// mSimpleRandom.cpp: mSimpleRandom NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Ion.h"
#include "mSimpleRandom.h"
#include <cstdlib>
#include <ctime>

//------------------------------------
// USING_RANDOM_SEED :: 1 Ȃ炵Ƃ
//                     
//			           0 ȂsSȂ̂ɂȂ
//				       thesis_work,thesis_work2  0̈
// USING_RANDOM_SEED_TIME :: 1 Ȃ玞ԂV[hɗ𔭐
//                           0 Ȃ RANDOM_SEED V[hɂ
// RANDOM_SEED :: USING_RANDOM_SEED_TIME  0 ̂Ƃ
//                ̃V[hɂȂ鐔
#define USING_RANDOM_SEED       1
#define USING_RANDOM_SEED_TIME  0
#define RANDOM_SEED             1033
//------------------------------------

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

mSimpleRandom::mSimpleRandom()
{

}

mSimpleRandom::~mSimpleRandom()
{

}

static void seedInitialize()
{
#if USING_RANDOM_SEED
	static bool is1st = true;
	if(is1st){
#if USING_RANDOM_SEED_TIME
	    srand( (unsigned)time( NULL ) ); //ŗ𔭐
#else  // USING_RANDOM_SEED_TIME
		srand(RANDOM_SEED);
#endif // USING_RANDOM_SEED_TIME
		is1st = false;
	}
#endif // USING_RANDOM_SEED
}

mDouble mSimpleRandom::getmValue()
{
	seedInitialize();
	return (double)rand()/(double)RAND_MAX;
}

mDouble mSimpleRandom::getNormal()
{
	//x,y[0,1]Ԃ̈lƂƂ
	//Kz (texŕ\)
	// $ v= \sqrt{-2 \sigma^2 \log_e(x)} \sin(2\pi y)+\mu $
	//œ邱Ƃł
	const mDouble tolerance = 5.0; //W΍tolerance{܂ł̕ϒl̕ϓŉ邱Ƃł
	const mDouble compareValue = exp(-tolerance*tolerance/2.0);
	mDouble x;
	do{
		x = getmValue();
	}while (x < compareValue);
	return sqrt(-2.0*log(x))
		*sin(2.0*PI*getmValue());
}

mDouble mSimpleRandom::getNormal(mDouble mu, mDouble sigma2)
{
	if(sigma2 < 0.0){
		return mu;
		//U0̂Ƃ͕ϒlԂĂ
	}
	// N(0,1)𗘗pĒl߂
	return sqrt(sigma2)*getNormal()+mu;
}

mInt mSimpleRandom::dummyInitialize()
{
    srand( (unsigned)time( NULL ) ); //ŗ𔭐
	return 0;
}

mDouble mSimpleRandom::getmValue(mDouble lower, mDouble upper)
{
	return lower+(upper-lower)*getmValue();
}

mInt mSimpleRandom::dummyVariable = mSimpleRandom::dummyInitialize();

const mDouble mSimpleRandom::PI = atan(1.0)*4.0;

const mDouble PI = mSimpleRandom::PI;


mInt mSimpleRandom::getNumber(mInt maxNumber)
{
	ASSERT(maxNumber != 0);
	seedInitialize();
	return rand()%maxNumber;
		//܂ŋ߂邩 % Zqg
}
