// Ion.h : ION AvP[ṼC wb_[ t@C
//

#if !defined(AFX_ION_H__EEF932A6_0FF5_11D4_A00F_E8E260E42D33__INCLUDED_)
#define AFX_ION_H__EEF932A6_0FF5_11D4_A00F_E8E260E42D33__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // C V{

#include "mParameter.h"
#include "mSimpleRandom.h"
#include "mMother.h"

#include "kSeedView.h"
#include "kGeneView.h"
#include "kDaughterView.h"
#include "kMotherView.h"
#include "kSizeView.h"
#include "kControl.h"

#include "IonDoc.h"
#include "ChildFrm.h"

/*-----------------------------------------------------------*/
#define Ion "Ion" //̃AvP[V̑ 2000.4.11
/*-----------------------------------------------------------*/

/////////////////////////////////////////////////////////////////////////////
// CIonApp:
// ̃NX̓̒`ɊւĂ Ion.cpp t@CQƂĂB
//

class CIonApp : public CWinApp
{
public:
	CString getExecutePath();
	void setPathName(CString pathName);
	void logSave();
	void logTurnLogSave();
	void waitFile();
	void fileUnlock();
	void fileLock();
	CString getPathName();
	void setSeedView(kSeedView* SeedView);
	void setGeneView(kGeneView* GeneView);
	void setDaughterView(kDaughterView* DaughterView);
	void setMotherView(kMotherView* MotherView);
	void setSizeView(kSizeView* SizedView);
	kSeedView* getSeedView();
	kGeneView* getGeneView();
	kDaughterView* getDaughterView();
	kMotherView* getMotherView();
	kSizeView* getSizeView();
	kControl* getControl();
	mDaughter* getChild();
	mMother* getMother();
	void closeWindowSeed();
	void openWindowSeed();
	static bool getOpenWindowSeed();
	void closeWindowGene();
	void openWindowGene();
	static bool getOpenWindowGene();
	void closeWindowDaughter();
	void openWindowDaughter();
	static bool getOpenWindowDaughter();
	void closeWindowMother();
	void openWindowMother();
	static bool getOpenWindowMother();
	void closeWindowSize();
	void openWindowSize();
	static bool getOpenWindowSize();
	CIonApp();

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CIonApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Cve[V
	//{{AFX_MSG(CIonApp)
	afx_msg void OnAppAbout();
	afx_msg void OnMenuitemControl();
	afx_msg void OnMenuitemWinmaneSeed();
	afx_msg void OnUpdateMenuitemWinmaneSeed(CCmdUI* pCmdUI);
	afx_msg void OnMenuitemWinmaneGene();
	afx_msg void OnUpdateMenuitemWinmaneGene(CCmdUI* pCmdUI);
	afx_msg void OnMenuitemWinmaneDaughter();
	afx_msg void OnUpdateMenuitemWinmaneDaughter(CCmdUI* pCmdUI);
	afx_msg void OnMenuitemWinmaneMother();
	afx_msg void OnUpdateMenuitemWinmaneMother(CCmdUI* pCmdUI);
	afx_msg void OnMenuitemWinmaneSize();
	afx_msg void OnUpdateMenuitemWinmaneSize(CCmdUI* pCmdUI);
	afx_msg void OnMenuitemSaveBirdView();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	CString executePath;
	void openInitialWindows();
	void forceExit();
	void logSaveIn(const CString& filename,mEnergy* energy);
	void logSaveIn(const CString& filename,const mInt& value);
	void logSaveIn(const CString& filename,const long& value);
	void logSaveIn(const CString& filename,const mDouble& value);
	volatile bool b_isFileAccess;

	kSeedView* pSeedView;
	kGeneView* pGeneView;
	kDaughterView* pDaughterView;
	kMotherView* pMotherView;
	kSizeView* pSizeView;
	kControl* control;
	mMother* Mayu;
	static bool bOpenSeed;
	CIonDoc* pSeedDoc;
	CChildFrame* pSeedFrame;
	CMultiDocTemplate* pSeedTemplate;
	static bool bOpenGene;
	CIonDoc* pGeneDoc;
	CChildFrame* pGeneFrame;
	CMultiDocTemplate* pGeneTemplate;
	static bool bOpenDaughter;
	CIonDoc* pDaughterDoc;
	CChildFrame* pDaughterFrame;
	CMultiDocTemplate* pDaughterTemplate;
	static bool bOpenMother;
	CIonDoc* pMotherDoc;
	CChildFrame* pMotherFrame;
	CMultiDocTemplate* pMotherTemplate;
	static bool bOpenSize;
	CIonDoc* pSizeDoc;
	CChildFrame* pSizeFrame;
	CMultiDocTemplate* pSizeTemplate;

	CString pathName;
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_ION_H__EEF932A6_0FF5_11D4_A00F_E8E260E42D33__INCLUDED_)
