// mFlower.cpp: mFlower NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Ion.h"
#include "mFlower.h"
#include "mSeed.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

mFlower::mFlower()
{

}

mFlower::~mFlower()
{

}

mFlower::mFlower(mSeed* seed,mPoint3D* centerPoint3D,mDouble radius)
	:mFlowerLeaf(seed,centerPoint3D,radius)
{

}

CString mFlower::toString()
{
	CString returnString="F "; //Fn܂͉̂
	returnString+=centerPoint3D->toString();
	CString addString;
	addString.Format(" %.10lf ",radius);
	returnString+=addString;
	returnString+=seed->getCenterPoint3D()->toString();
	returnString+=" ";
	returnString+=seed->getID()->toString();
	return returnString;
}

mDouble mFlower::calculateRadius(mDouble energy)
{
	if(energy <= 0.0){
		return 0.0;
	}
	return pow(3.0*energy/4.0/PI/mParameter::mFlower_calorie,
		1.0/3.0);
}

mDouble mFlower::getCalorie()
{
	return getVolume()*mParameter::mFlower_calorie;
}

mDouble mFlower::getKeepCalorie()
{
	return getCalorie()*mParameter::mFlower_keep_calorie;
}
