// mGene.cpp: mGene NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Ion.h"
#include "mGene.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

mGene::mGene()
{
	//ftHgRXgN^͎gȂ
}

mGene::mGene(mGeneList* geneList)
{
	code = NULL;
	this->geneList = geneList;
	ID = new mID;
	seeds = new vector<mSeed*>;
		//͂Ƃdelete邱
		//Aꂼ̒gdeleteȂ
	size = 0;
}

mGene::mGene(mGeneList *geneList, mID *ID)
{
	code = NULL;
	this->geneList = geneList;
	if(this->ID){
		delete this->ID;
	}
	this->ID = ID;
	seeds = new vector<mSeed*>;
		//͂Ƃdelete邱
		//Aꂼ̒gdeleteȂ
	if(ID){
		size = ID->getSize();
	}
}

mGene::~mGene()
{
	if(code){
		delete[] code;
		code = NULL;
	}
	if(ID){
		delete ID;
		ID = NULL;
	}
	if(seeds){
		seeds->clear();
		delete seeds;
		seeds =NULL;
	}
}

vector<mSeed*>* mGene::getSeeds()
{
	return seeds;
}

CString mGene::toString()
{
	if(ID){
		return CString("Gene ")+ID->toString();
	}
	return "Gene with No ID";
}

void mGene::selfLoad(istream &is)
{
	CString comment;
	is >>comment;
	ID->selfLoad(is);
	//R[h̃TCYID擾
	size = ID->getSize();
	code = new mInt[size];
		//̓fXgN^delete邱
	for(mInt i=0;i<size;++i){
		is >> code[i] ;
	}
	is >> comment;

}

void mGene::selfSave(ostream &os)
{
	os << "/*mGene strat*/" <<endl;
	ID->selfSave(os);
	for(mInt i=0;i<size;++i){
		os << code[i] <<' ';
	}
	os << endl;
	os <<"/*mGene end*/" <<endl;
}

mInt* mGene::getCode()
{
	return code;
}

mInt mGene::getSize()
{
	return size;
}

mID* mGene::getID()
{
	return ID;
}

mGeneList* mGene::getGeneList()
{
	return geneList;
}

bool mGene::compareTo(mGene *otherGene)
{
	if(otherGene==NULL){
		//̂̂Ƃ͓ɂȂȂ
		return false;
	}
	mID* otherID = otherGene->getID();
	if(ID->compareTo(otherID)){
		//IDȂ瓯
		return true;
	}
	//IDŔׂȂΒڔr
	if(size != otherGene->getSize()){
		//TCYΓR[hɂ͂ȂȂ
		return false;
	}
	mInt* otherCode = otherGene->getCode();
	if(otherCode==NULL){
		return false;
	}
	for(mInt i=0;i<size;++i){
		if(code[i] != otherCode[i]){
			//łႤƈႤ
			return false;
		}
	} // end of for
	//܂łΓ
	return true;
}

mGene* mGene::makeGene(mGene *motherGene, mGene *fatherGene, mDouble per)
{
	//쐬daughter geneł
	//code,size,seeds,geneList͕Kv
	//ID͕sv

	const mInt* motherCode = motherGene->getCode();
	const mInt motherSize = motherGene->getSize();

	const mInt* fatherCode = fatherGene->getCode();
	const mInt fatherSize = fatherGene->getSize();

	//܂ꂼ̃R[h gene_separateŐ؂
	const mInt gene_separate = mCPU::gene_separate;
	vector<vector<mInt> > motherVector;
	vector<vector<mInt> > fatherVector;

	vector<vector<mInt> >::iterator itMother;
	vector<vector<mInt> >::iterator itFather;
	vector<vector<mInt> >::iterator itDaughter;

	mInt index;
	for(index = 0; index<motherSize;++index){
		vector<mInt> internalVector;
		for( ; index < motherSize;++index){
			mInt value = motherCode[index];
			internalVector.push_back(value);
			if(value == gene_separate){
				//gene_separatêƂŐ؂荏
				break;
			}
		} //end of inner for
		motherVector.push_back(internalVector);
	}//end of outer for

	for(index = 0; index<fatherSize;++index){
		vector<mInt> internalVector;
		for( ; index < fatherSize;++index){
			mInt value = fatherCode[index];
			internalVector.push_back(value);
			if(value == gene_separate){
				//gene_separatêƂŐ؂荏
				break;
			}
		} //end of inner for
		fatherVector.push_back(internalVector);
	}//end of outer for

	vector<vector<mInt> > daughterVector;
	for(itMother = motherVector.begin();
			itMother != motherVector.end();
			++itMother){
		vector<mInt> internalVector;
		for(vector<mInt>::iterator itInter = (*itMother).begin();
				itInter != (*itMother).end();
				++itInter){
			internalVector.push_back(*itInter);
		}
		daughterVector.push_back(internalVector);
	}
	
	// motherfatherƂ̊^
	// father̂ԂRs[
	const mDouble effect = per * mParameter::mGene_maxFatherEffect;
	const mInt randomVectorSize = min(motherVector.size(),fatherVector.size());

	for(index=0,itFather=fatherVector.begin(),itDaughter=daughterVector.begin();
			index < randomVectorSize ;
			++itFather,++itDaughter,++index){
		if(mSimpleRandom::getmValue()<effect){
			//̂Ƃmother̃R[hfather̃R[h𗘗p
			(*itDaughter).clear();
			for(vector<mInt>::iterator itInter= (*itFather).begin();
					itInter != (*itFather).end();
					++itInter){
				(*itDaughter).push_back(*itInter);
			}
		} // end of if
	} //end of for

	//܂łmotherfather̒ڂ̎󂯎͏I
	//Ƃ͊mIɕςĂƂ

	//܂vectorxōs
	if(mSimpleRandom::getmValue()<mParameter::mGene_vectorVariation){
		index=mSimpleRandom::getNumber(daughterVector.size()+1);
		if(mSimpleRandom::getmValue()<0.5){
			//̊mő₷
			//index̒Oɓ\
			if(mSimpleRandom::getmValue()<effect){
				//father̕^[Qbg
				daughterVector.insert(daughterVector.begin()+index,
					fatherVector.at(mSimpleRandom::getNumber(fatherVector.size())));
			}else{
				//mother̕^[Qbg
				daughterVector.insert(daughterVector.begin()+index,
					motherVector.at(mSimpleRandom::getNumber(motherVector.size())));
			}
		}else{
			//̊mŌ炷
			//index폜
			if(index != daughterVector.size()){
				daughterVector.erase(daughterVector.begin()+index);
			}
		}
	}

	//ɃTCYς@Ŗ߂ς
	if(mSimpleRandom::getmValue() < mParameter::mGene_sizeVariation){
		if(daughterVector.size() ==0){
			//gȂ̂ŁA_Ȗ߂ЂƂĂ
			vector<mInt> tempVector;
			tempVector.push_back(mSimpleRandom::getNumber(mCPU::OperatorNumber));
			daughterVector.push_back(tempVector);
		}else{
			index = mSimpleRandom::getNumber(daughterVector.size());
			
			//index̒gɑ}邩A폜邩
			vector<mInt> targetVector = daughterVector.at(index);
			vector<mInt>::iterator targetIndex = targetVector.begin()
				+(mSimpleRandom::getNumber(targetVector.size()));
			
			if(mSimpleRandom::getmValue()<0.5){
				//̊mŖ߂
				mInt insertOperator = mSimpleRandom::getNumber(mCPU::OperatorNumber);
				targetVector.insert(targetIndex,insertOperator);
			}else{
				//̊mŖ߂
				targetVector.erase(targetIndex);
			}
			daughterVector.at(index) = targetVector;
		}
	} //end of if , size variation

	//܂łŃTCYm肵
	//new ŔzƂ邱Ƃł
	mInt newSize = 0;
	for(itDaughter = daughterVector.begin();
			itDaughter != daughterVector.end();
			++itDaughter){
		newSize += (*itDaughter).size();
	}
	mGene* daughterGene = new mGene(motherGene->geneList);
		//̃CX^X͂̃NXdeleteȂ
	if(newSize == 0){
		++newSize;
		//gȂ̂ŁA_Ȗ߂ЂƂĂ
		vector<mInt> tempVector;
		tempVector.push_back(mSimpleRandom::getNumber(mCPU::OperatorNumber));
		daughterVector.push_back(tempVector);
	}

	daughterGene->size = newSize;
	daughterGene->code = new mInt[newSize];
		//̃CX^X͂̃NXdeleteȂ

	index = 0;
	mInt* daughterCode = daughterGene->code;
	//daughterVector̃Rs[
	for(itDaughter = daughterVector.begin();
			itDaughter != daughterVector.end();
			++itDaughter){
		for(vector<mInt>::iterator targetIndex = (*itDaughter).begin();
				targetIndex != (*itDaughter).end();
				++targetIndex){
			daughterCode[index] = *targetIndex;
			++index;
		} // end of inner for
	} // end of outer for
	
	//Ƃ͖߂Ƃ̓ˑRψ
	if(mSimpleRandom::getmValue() < mParameter::mGene_operatorVariation){
		//indexԖڂ̖߂ω
		index = mSimpleRandom::getNumber(daughterGene->size);
		if(mSimpleRandom::getmValue() < mParameter::mGene_operatorRandomVariation){
			//߂_ɕω
			daughterCode[index] = mSimpleRandom::getNumber(mCPU::OperatorNumber);
		}else{
			//߂rbgŕω
			const mInt targetBit = 1 << 
				mSimpleRandom::getNumber(
					(mInt)(log((mDouble)mCPU::OperatorNumber)/log(2.0)));
				//Ń^[QbgƂȂ镔͂
			if(daughterCode[index] & targetBit){
				//݃rbgĂ
				daughterCode[index] -= targetBit;
			}else{
				//݃rbgĂȂ
				daughterCode[index] += targetBit;
			}
			//ŊOɏoĂ̂𒲐
			daughterCode[index] %= mCPU::OperatorNumber;
			if(daughterCode[index] < 0){
				daughterCode[index] +=mCPU::OperatorNumber;
			}
		} // end of inner if
	} //end of outer if
	return daughterGene;
}

void mGene::addNewSeed(mSeed *newSeed)
{
	if(seeds){
		for(vector<mSeed*>::iterator it = seeds->begin();
				it != seeds->end();
				++it){
			if(newSeed == *it){
				return;
			}
		}
		seeds->push_back(newSeed);
	}
}

void mGene::deleteSeed(mSeed *oldSeed)
{
	if(seeds){
		for(vector<mSeed*>::iterator itSeed = seeds->begin();
				itSeed != seeds->end();
				++itSeed){
			if((*itSeed)==oldSeed){
				//烊Xg菜
				seeds->erase(itSeed);
				// *itSeeddeleteȂ
				break;//forI
			}
		} //end of for
	} // end of if
}

mInt mGene::getSeedNumber()
{
	if(seeds){
		int j = seeds->size();
		return seeds->size();
	}
	return 0;
}

mGene* mGene::makeCopyGene(mGeneList *geneList, mGene *originalGene)
{
	mGene* copyGene = new mGene(geneList);
	copyGene->size = originalGene->size;
	if(copyGene->code){
		delete[] copyGene->code;
		copyGene->code = NULL;
	}
	copyGene->code = new mInt[copyGene->size];
	for(mInt i=0;i<copyGene->size;++i){
		copyGene->code[i]=originalGene->code[i];
	}
	return copyGene;
}

void mGene::setID(mID *ID)
{
	if(this->ID){
		delete this->ID;
	}
	this->ID = ID;
}

mGene* mGene::initialGene(mGeneList *geneList, mInt size, const mInt const *code)
{
	//ŐVW[
	//geneList,code,sizê݂܂Ă^Cvł
	//ق̂͌Ō߂Ƃ
	
	mGene* newGene = new mGene(geneList);
	newGene->size = size;
	newGene->code = new mInt[size];
	for(mInt i=0; i < size ; ++i){
		newGene->code[i] = code[i];
	}
	return newGene;
}

CString mGene::makeCodeString()
{
	mInt j;
	CString codeString,addString;
	codeString += "ID:";
	codeString += ID->toString();
	codeString += "\x0d\x0a";
	for(j=0;j<size;++j){
		addString.Format("%d : %02x : %s",j,code[j],mCPU::OperatorName[code[j]]);
		codeString += addString + "\x0d\x0a";
	}
	return codeString;
}
