// mGene.h: mGene NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MGENE_H__136E5F21_1249_11D4_A00F_EB25FC123F33__INCLUDED_)
#define AFX_MGENE_H__136E5F21_1249_11D4_A00F_EB25FC123F33__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Ion.h"
#include "mGeneList.h"
class mGeneList;
#include "mID.h"
class mID;
#include "mSeed.h"
class mSeed;
#include "mSuperClass.h"
#include "mParameter.h"	// ClassView ɂĒǉ܂B

//W[i[NX
class mGene : public mSuperClass  
{
public:
	CString makeCodeString();
	static mGene* initialGene(mGeneList* geneList,mInt size,const mInt const* code); //ŏ̃W[邽߂̃\bh
	void setID(mID* ID); //IDZbg
	static mGene* makeCopyGene(mGeneList* geneList,mGene* originalGene); //mMother::SeedExchangêƂɎgRs[
	mInt getSeedNumber(); //݂̃V[h̃V[hQƂĂ邩
	void deleteSeed(mSeed* oldSeed); //ÂV[h폜
	void addNewSeed(mSeed* newSeed); //VV[ho^
	static mGene* makeGene(mGene* motherGene,mGene* fatherGene,mDouble per); //motherfatherper̊gene
	bool compareTo(mGene* otherGene); //ق̃W[Ƃ̔r
	mGeneList* getGeneList();
	mID* getID();
	mInt getSize();
	mInt* getCode();
	void selfSave(ostream& os);
	void selfLoad(istream& is);
	CString toString();
	mGene(mGeneList* geneList,mID* ID); //W[ǂݍݗp
	vector<mSeed*>* getSeeds(); //̃W[𗘗pĂV[h̐
	mGene(mGeneList* geneList);//VW[p
	virtual ~mGene();

private:
	mInt size; //̃W[̃TCY
	mInt* code; //̃W[̃R[h{
	vector<mSeed*>* seeds; //̃W[𗘗pĂV[h̐
	mID* ID; //̃W[ID
	mGeneList* geneList; //̃W[W߂Ă郊Xg
	mGene(); //ftHgRXgN^͎gȂ
};

#endif // !defined(AFX_MGENE_H__136E5F21_1249_11D4_A00F_EB25FC123F33__INCLUDED_)
