// mLeaf.cpp: mLeaf NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Ion.h"
#include "mLeaf.h"
#include "mSeed.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

mLeaf::mLeaf()
{

}

mLeaf::~mLeaf()
{

}

mLeaf::mLeaf(mSeed* seed,mPoint3D* centerPoint3D,mDouble radius)
	:mFlowerLeaf(seed,centerPoint3D,radius)
{

}

CString mLeaf::toString()
{
	CString returnString="L "; //Ln܂̂͗t
	returnString+=centerPoint3D->toString();
	CString addString;
	addString.Format(" %.10lf ",radius);
	returnString+=addString;
	returnString+=seed->getCenterPoint3D()->toString();
	returnString += " ";
	returnString += seed->getID()->toString();
	return returnString;
}

mDouble mLeaf::calculateRadius(mDouble energy)
{
	if(energy <= 0.0){
		return 0.0;
	}
	return pow(3.0*energy/4.0/PI/mParameter::mLeaf_calorie,
		1.0/3.0);
}

mDouble mLeaf::getCalorie()
{
	return getVolume()*mParameter::mLeaf_calorie;
}

mDouble mLeaf::getKeepCalorie()
{
	return getCalorie()*mParameter::mLeaf_keep_calorie;

}
