// mMother.cpp: mMother NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Ion.h"
#include "mMother.h"
#include <iomanip>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

const CString mMother::STATENAME[] ={
		"SUN_LIGHT",
		"INITIAL_EXECUTE",
		"PRE_EXECUTE",
		"EXECUTE",
		"AFTER_EXECUTE",
};

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

mMother::mMother()
{
	thread = NULL;
	//ŐCX^X̓fXgN^delete邱
	thread = new mSimpleThread(this,THREAD_PRIORITY_LOWEST);
	stopper = NULL;
	stopper = new mSimpleStopper(true);

	//AfxMessageBox("KoharuN܂");
	Koharu = new mDaughter(this,"Koharu",true);
#if SISTER
	Yusemi = new mDaughter(this,"Yusemi",false);
	//̏Ԃ͏dvȂ
#endif
	currentState = SUN_LIGHT; //Ƃ肠̏
	b_hasStarted = NULL; //ŏ̓XbhĂȂB
}

mMother::~mMother()
{
	if(thread){
		delete thread;
		thread = NULL;
	}
	if(stopper){
		delete stopper;
		stopper = NULL;
	}
	if(Koharu){
		delete Koharu;
		Koharu = NULL;
	}
#if SISTER
	if(Yusemi){
		delete Yusemi;
		Yusemi = NULL;
	}
#endif
}

CString mMother::toString()
{
	return "Mayu";
}

void mMother::selfLoad(CString pathName)
{
	if(stopper == NULL){
		return;
	}
	if(isRunning()){
		return; //ĂƂ̓[hłȂ
	}
	mParameter::selfLoad(pathName);
	ifstream is;
	is.open((getFileName(pathName)).operator LPCTSTR());
		//ŊJĂ낢Ə
	CString comment;
	is >> comment;
	int state;
	is >> state;
	currentState = (STATE)state;
	is.close();

	//qŊ撣
	Koharu->selfLoad(pathName);
#if SISTER
	Yusemi->selfLoad(pathName);
#endif
}

void mMother::selfSave(CString pathName)
{
	if(stopper == NULL){
		return;
	}
	if(isRunning()){
		return; //ĂƂ̓Z[ułȂ
	}
	ofstream os;
	os.open((getFileName(pathName)).operator LPCTSTR());
		//ŊJĂ낢Ə
	CString nameString = toString();
	nameString = nameString+" is living in "+Ion+" !!";
	os << nameString << endl;
	os << (int)currentState << endl;
		//int͖IɂĂ邾
	os.close();

	//qŊ撣
	Koharu->selfSave(pathName);
#if SISTER
	Yusemi->selfSave(pathName);
#endif
	mParameter::selfSave(pathName);
}

CIonApp* mMother::getCurrentApp()
{
	return (CIonApp*)AfxGetApp();
}

mMother::STATE mMother::getCurrentState()
{
	return currentState;
}

mDaughter* mMother::getChild()
{
	return Koharu;
		//ɂKoharuɂ͊OANZXł邪
		//Yusemiɂ͊ÕANZXłȂȂ
}

void mMother::seedExchange(mDaughter *from, mDaughter *to)
{
	//from̂ȂspecialVector̒g
	//tôȂseedVectorɈڂ
	vector<mSeed*>* fromSpecialVector = from->getSeedList()->getSpecialVector();
	vector<mSeed*>::iterator itSeed;

	for(itSeed = fromSpecialVector->begin();
			itSeed != fromSpecialVector->end();
			++itSeed){
		mGene* copyGene = mGene::makeCopyGene(to->getGeneList(),(*itSeed)->getGene());
			//ꉞ\̂߂̃W[Ă
		mID* nextID = NULL;
		mGene* nextGene = NULL;
			//topIDGene
			//͂̃\bhdeleteȂ
		if(to->getGeneList()->decideID(copyGene,&nextID,&nextGene)){
			//VW[ł͂Ȃ
			//̂ƂnextIDnextGeneɂ̓e
			if(copyGene){
				delete copyGene;
				copyGene = NULL;
			}
				//Rs[̃W[͂KvȂ
		}else{
			//VGeneł
			nextGene = copyGene;
			to->incrementCurrentTime();
				//ID̏d邽
			nextID = to->getGeneList()->makeNewID(nextGene->getSize());
			nextGene->setID(nextID);
			to->getGeneList()->addNewGene(nextGene);
		}

		from->getGeneList()
			->deleteSeed(*itSeed,(*itSeed)->getGene());
			//itSeedfrom̃W[؂藣
		(*itSeed)->changeGene(nextGene,to->getSeedList());
			//seedGeneseedListւ
		to->getSeedList()->addSpecialSeed(*itSeed);
			//to̕seedVectorɒǉ

	} // end of for,itSeed
	fromSpecialVector->clear();
		//seedVector̒gꂢ
}

void mMother::works()
{
	switch(currentState){
	case EXECUTE: //execute͍ł񐔂̂caseŏɗ
		execute();
		break;
	case PRE_EXECUTE: //execute͍ł񐔂̂caseŏɗ
		pre_execute();
		break;
	case SUN_LIGHT:
		sun_light();
		break;
	case INITIAL_EXECUTE:
		initial_execute();
		break;
	case AFTER_EXECUTE:
		after_execute();
		break;
	}

	//ŃtF[YƂ̕\s
	getCurrentApp()->getControl()->m_execute.SetWindowText(makeString());
	if(getCurrentApp()->getMotherView()){
		CIonApp* app = getCurrentApp();
		getCurrentApp()->getMotherView()->currentView(currentState);
	}

}

void mMother::run()
{
	while(true){
		works(); //낢Ȏd
		stopper->wait(); //Ƃ܂ĂKvƂ͂Ƃ܂Ă
	}
}

bool mMother::isSpecial()
{
	//̊mŐ܂ꂽ΂̃V[h
	//specialVectorɂ͂
#if SISTER
	if(mSimpleRandom::getmValue()<mParameter::mMother_makeSpecial){
		return true;
	}
#endif
	return false;
		//YUSEMIłȂƂׂ͂specialVectorɂ͂Ȃ
}

void mMother::sun_light()
{
	//̌vZ
	Koharu->getField()->calculateSun();
#if SISTER
	Yusemi->getField()->calculateSun();
#endif
	currentState = INITIAL_EXECUTE;
}

void mMother::initial_execute()
{
	//s̏
	Koharu->getSeedList()->init_execute();
#if SISTER
	Yusemi->getSeedList()->init_execute();
#endif
	currentState = PRE_EXECUTE;
}

void mMother::pre_execute()
{
	mSeed* targetSeed = Koharu->getSeedList()->getSeedPointer();
	if(targetSeed){
		kSeedView* seedView = getCurrentApp()->getSeedView();
		if(seedView){
			//seedViewωĂ݂
			seedView->dataDisplay(targetSeed);
		}
	}
	currentState = EXECUTE;
}

void mMother::execute()
{
	//ۂ̎s
	mSeed* targetSeed = Koharu->getSeedList()->getSeedPointer();
	Koharu->execute();

	if(targetSeed){
		kSeedView* seedView = getCurrentApp()->getSeedView();
		if(seedView){
			//seedViewωĂ݂
			seedView->dataDisplay(targetSeed);
		}
	}

#if SISTER
	if(Yusemi->getSeedList()->isOverExceute() == false){
		Yusemi->execute();
	}
#endif
	if(Koharu->getSeedList()->isOverExceute()){
		currentState = AFTER_EXECUTE;
		//KoharuIĂĂYusemîقIĂȂƂ
		//YusemîقI点ē
#if SISTER
		while(Yusemi->getSeedList()->isOverExceute() == false){
			Yusemi->getSeedList()->execute();
		}
#endif
	}else{
		//IĂȂƂpre_executeɍs
		currentState = PRE_EXECUTE;
	}
}

void mMother::after_execute()
{
	//executě㏈
	Koharu->getSeedList()->after_execute();
#if SISTER
	Yusemi->getSeedList()->after_execute();
	//specialSeed̓ւ
	seedExchange(Koharu,Yusemi);
	seedExchange(Yusemi,Koharu);
#endif
	currentState = SUN_LIGHT;

	Koharu->addTurnNumber();
#if SISTER
	Yusemi->addTurnNumber();
#endif

	view_change(); //view_change̒ɓ
}

void mMother::view_change()
{
	//ŃC^[tF[X̂قŕςׂƂς

	kDaughterView* daughterView = getCurrentApp()->getDaughterView();
	if(daughterView){
		daughterView->dataDisplay();
	}
	kSizeView* sizeView = getCurrentApp()->getSizeView();
	if(sizeView){
		sizeView->dataDisplay();
	}
	kSeedView* seedView = getCurrentApp()->getSeedView();
	if(seedView){
		//seedViewID̑Î폜Ă
		seedView->deleteComboSelection();
	}
	kGeneView* geneView = getCurrentApp()->getGeneView();
	if(geneView){
		//geneViewID̑Î폜Ă
		geneView->deleteComboSelection();
	}

	//Oւ̃Z[u
	getCurrentApp()->logSave();
	//d_IɃO^[̃O
	getCurrentApp()->logTurnLogSave(); 

}

CString mMother::getFileName(CString pathName)
{
	return pathName+toString()+".lives";
}

bool mMother::isRunning()
{
	if(stopper == NULL){
		return false;
	}
	return (thread->isRunning() && (!stopper->isWaiting()));
		//ĂtrueԂ
		//ĂȂfalseԂ
}

void mMother::lock()
{
	if(stopper == NULL){
		return;
	}
	stopper->lock();
/*	while(!stopper->isWaiting()){
		//ĂԂ͑҂
		//TXyhɋ߂
	}
*/
}

void mMother::unlock()
{
	if(stopper == NULL){
		return;
	}
	stopper->unlock();
		//Ŏ~܂Ă̂o
		//TXyh݂̉Ȃ
/*	while(stopper->isWaiting()){
	}
*/
}

void mMother::start()
{
	thread->start();
		//XbhX^[g
	b_hasStarted = true;
}

CString mMother::makeString()
{
	CString returnString = STATENAME[currentState];
	if(currentState == EXECUTE || currentState == PRE_EXECUTE){
		CString addString;
		mInt bunshi = getChild()->getSeedList()->getM();
		mInt bunbo = getChild()->getSeedList()->getSeedVector()->size();
		addString.Format("(%0d/%0d)",bunshi,bunbo);
		returnString += addString;
	}
	return returnString;
}

bool mMother::hasStarted()
{
	return b_hasStarted;
}


void mMother::initialize(CString geneFileName,CString ParameterFileName)
{
	if(ParameterFileName.Compare("")!=0){
		//p[^[t@Cݒ肳Ă̂ł̗p
		mParameter::selfLoad(ParameterFileName,true);
	}
	Koharu->initialize(geneFileName);
#if SISTER
	Yusemi->initialize(geneFileName);
#endif
}
