// mPoint3D.cpp: mPoint3D NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Ion.h"
#include "mPoint3D.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

mPoint3D::mPoint3D()
{
	x=0.0;
	y=0.0;
	z=0.0;
}

mPoint3D::~mPoint3D()
{

}

void mPoint3D::selfSave(ostream &os)
{
	os<<"/*mPoint3D start*/"<<endl;
	os<<x<<' '<<y<<' '<<z<<endl; //W̏o
	os<<"/*mPoint3D end*/"<<endl;
}

void mPoint3D::selfLoad(istream &is)
{
	CString comment;
	is>>comment;
	is>>x>>y>>z; //Wǂݎ
	is>>comment;
}

CString mPoint3D::toString()
{
	CString returnString;
	returnString.Format("%lf %lf %lf",x,y,z);
	return returnString;
}

mPoint3D::mPoint3D(const mPoint3D &other)
{
	x=other.x;
	y=other.y;
	z=other.z;
}

mPoint3D& mPoint3D::operator=(const mPoint3D &other)
{
	if(this==&other){
		return *this;
	}
	x=other.x;
	y=other.y;
	z=other.z;
	return *this; //dummy return
}

mDouble mPoint3D::getLengthSquare()
{
	return x*x+y*y+z*z;
}

mDouble mPoint3D::getDistanceSquare(mPoint3D *centerPoint3D, mPoint3D *endPoint3D)
{
	mDouble x=centerPoint3D->x - endPoint3D->x;
	mDouble y=centerPoint3D->y - endPoint3D->y;
	mDouble z=centerPoint3D->z - endPoint3D->z;
	return x*x+y*y+z*z;

}

mPoint3D* mPoint3D::addPoint3D(mPoint3D *firstPoint3D, mPoint3D *secondPoint3D)
{
	mPoint3D* returnPoint3D = new mPoint3D;
		//̃CX^X͂ق̂ƂłƏ
	returnPoint3D->x = firstPoint3D->x + secondPoint3D->x;
	returnPoint3D->y = firstPoint3D->y + secondPoint3D->y;
	returnPoint3D->z = firstPoint3D->z + secondPoint3D->z;
	return returnPoint3D;
}

mPoint3D::mPoint3D(const mDouble x, const mDouble y, const mDouble z)
{
	this->x = x;
	this->y = y;
	this->z = z;

}
