// mSeed.cpp: mSeed NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Ion.h"
#include "mSeed.h"
#include "mDaughter.h"
#include "mGeneList.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

mSeed::mSeed()
{

}


mSeed::mSeed(mGene *gene, mSeedList *seedList, mID *ID, mPoint3D *centerPoint3D, mInt isBirth,mDouble initialEnergy)
{
	this->gene = gene;
	this->seedList = seedList;
	//܂ł̗vf͂̃NXdeleteȂ

	this->ID = NULL;
	this->centerPoint3D = NULL;
	this->CPU = NULL;
	this->partsList = NULL;
		//͈̕ꉞ̕ی
	
	this->ID = ID;
	this->centerPoint3D=centerPoint3D;
	//̂Q͂̃NXdelete邱

	this->isBirth=isBirth;

	partsList = new mPartsList(this,"N");
	CPU = new mCPU(this);
	//KpartsListɐ邱
	//ȂCPŨRXgN^œo^łȂ
	//̂Q͂̃NXdelete邱
	CPU->getEnergy()->addTotalEnergy(initialEnergy);

	turnNumber = 0;
		//Ƃ肠turnNumber = NULLƂĂ
	evaluationValue = mParameter::mSeed_initialEvaluationValue;
		//Ƃ肠̕]l̏
}

mSeed::~mSeed()
{
	if(ID){
		delete ID;
		ID = NULL;
	}
	if(centerPoint3D){
		delete centerPoint3D;
		centerPoint3D = NULL;
	}
	if(CPU){
		delete CPU;
		CPU = NULL;
	}
	if(partsList){
		delete partsList;
		partsList = NULL;
	}
}

mSeed::mSeed(mSeedList *seedList)
{
	this->gene = NULL;
	this->seedList = seedList;
	//܂ł̗vf͂̃NXdeleteȂ
	this->ID = new mID;
	this->centerPoint3D= new mPoint3D;
	//̂Q͂̃NXdelete邱

	this->isBirth=false;

	this->partsList = new mPartsList(this);
	this->CPU = new mCPU(this);
	//̂Q͂̃NXdelete邱
	turnNumber = 0;
	evaluationValue = mParameter::mSeed_initialEvaluationValue;
		//Ƃ肠̕]l̏
}

CString mSeed::toString()
{
	CString returnString="S "; //Sn܂̂̓V[h
	returnString+=centerPoint3D->toString();
	returnString+= " ";
	returnString+= ID->toString();
	return returnString;
}

void mSeed::selfLoad(istream &is)
{
	CString comment;
	is>>comment;
	//[h͂ꂼ̗vfɊ撣Ă炤
	mID* geneID = new mID;
	geneID->selfLoad(is);
	gene=seedList->getDaughter()->getGeneList()->getGene(geneID);
	gene->addNewSeed(this);
		//W[ւ̓o^
	delete geneID; //͕KvȂĂ
	ID->selfLoad(is);
	centerPoint3D->selfLoad(is);
	CPU->selfLoad(is);
	partsList->selfLoad(is);
	is>>turnNumber>>isBirth ;
	calculateEvaluationValue();
	is>>comment;

}

void mSeed::selfSave(ostream &os)
{
	os<<"/*mSeed start*/"<<endl;
	//Z[u͂ꂼ̗vfɊ撣Ă炤
	gene->getID()->selfSave(os);
	ID->selfSave(os);
	centerPoint3D->selfSave(os);
	CPU->selfSave(os);
	partsList->selfSave(os);
		//partsListcenterPoint3Dɏ邱
		//ȂrebuildłȂ
	os<<turnNumber<<' '<<
		isBirth<<' '<<endl;
	os<<"/*mSeed end*/"<<endl;

}

mSeedList* mSeed::getSeedList()
{
	return seedList;
}

mGene* mSeed::getGene()
{
	return gene;
}

mID* mSeed::getID()
{
	return ID;
}

mCPU* mSeed::getCPU()
{
	return CPU;
}

mPartsList* mSeed::getPartsList()
{
	return partsList;
}

mPoint3D* mSeed::getCenterPoint3D()
{
	return centerPoint3D;
}

mInt mSeed::getIsBirth()
{
	return isBirth; 
}

mInt mSeed::getTurnNumber()
{
	return turnNumber;
}

bool mSeed::canMakeBowl(mPoint3D *centerPoint3D, mDouble radius)
{
	//partsListɈڍs
	return partsList->canMakeBowl(centerPoint3D,radius);
}

bool mSeed::canMakeEdge(mPoint3D *otherCenterPoint3D, mPoint3D *otherEndPoint3D)
{
	//partsListɈڍs
	return partsList->canMakeEdge(otherCenterPoint3D,otherEndPoint3D);
}

mDouble mSeed::calculateEvaluationValue()
{
	mDouble energy = CPU->getEnergy()->getCurrentEnergy();
	mDouble calorie = partsList->getCalorie();
	mDouble value;

#if 0
	if(energy < calorie){
		energy = calorie;
	}
	value = CPU->getBreedNumber()+log(log(energy/calorie)+1)
		- pow((mDouble)CPU->getBreedNumber()/(mDouble)turnNumber,2.0);
#endif
	value = (mDouble)CPU->getBreedNumber()+1.0;
	/*
	ݎgĂ]l
	energy:     ݎĂGlM[
	calorie:    1^[邽߂̃J[
	turnNumber: ^[Ă
	ɂČvZÄӖ
	݂̃GlM[łꂩ牽Ȃ
	т^[
	܂ŐĂ^[
	̋ߎlł
	*/

	if( CPU->getBreedNumber() == 0 && 
		turnNumber > mParameter::mSeed_turn_effect * ID->getSize()){
		value = -1.0;
	}
	if( energy <= 0.0){
		value = -1.0;
	}

	evaluationValue = value;
	return value;

}
mDouble mSeed::getEvaluationValue()
{
	//̃\bhcalculateEvaluationValue
	//gĂĂԂ
	return evaluationValue;
}

void mSeed::setIsBirth(mInt Value)
{
	isBirth=Value;
}

void mSeed::execute()
{
	++turnNumber;
	//s
	CPU->getEnergy()->addTotalEnergy(partsList->aggregateEnergy());
	//GlM[𓾂Ƃ`Ă
	CPU->execute();
	//CPU̕execute
	calculateEvaluationValue();
	//̒iKŕ]Ă܂
}


bool mSeed::greaterThan(mSeed *mySeed, mSeed *yourSeed)
{
	//ɗseedƂ
	// calculateEvaluationValueĂł邱
	return mySeed->evaluationValue 
			> 
		yourSeed->evaluationValue;
}

void mSeed::changeGene(mGene *gene, mSeedList *seedList)
{
	this->gene = gene;
	this->seedList = seedList;
	this->CPU->changeGene(gene);
}

mInt mSeed::getBreedNumber()
{
	if(CPU){
		return CPU->getBreedNumber();
			//CPUĂ
	}
	return 0;
}

bool mSeed::IDSort(mSeed *mine, mSeed *yours)
{
	mID* mineID = mine->ID;
	mID* yourID = yours->ID;

	if(mineID->getSize() < yourID->getSize()){
		return true;
	}
	if(mineID->getSize() > yourID->getSize()){
		return false;
	}
	if(mineID->getBornTime() < yourID->getBornTime()){
		return true;
	}
	if(mineID->getBornTime() > yourID->getBornTime()){
		return false;
	}
	if(mineID->getIs1st() > yourID->getIs1st()){
		return true;
	}
	if(mineID->getIs1st() < yourID->getIs1st()){
		return false;
	}
	return true;
}
