// mSimpleThread.cpp: mSimpleThread NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Ion.h"
#include "mSimpleThread.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

mSimpleThread::mSimpleThread()
{
	target=NULL;
	aliving=true;
	running=false;
}

static UINT mSimpleThreadRun(LPVOID pParam)
{
	mSimpleRunnable* target=(mSimpleRunnable*)pParam;
	if(target!=NULL){
		target->run();
	}
	while(true){
		//̊֐͏IȂ̂
		// stop()\bhpďI
		Sleep(INFINITE);
		//ꉞ̎ԉ҂
	};
	return NULL;
}

mSimpleThread::mSimpleThread(mSimpleRunnable* target,int nPriority)
{
	this->target=target;
	this->nPriority=nPriority;
	thread = NULL;
	aliving=false;
	if(target!=NULL && thread==NULL){
		thread=AfxBeginThread(mSimpleThreadRun,target,
			nPriority,0,CREATE_SUSPENDED);
			//ŏ̓TXyhԂŋN
			//startŎsn܂
		thread->m_bAutoDelete = false ;//Iɏ̂h
	}
	aliving=true;
	running=false;
}

mSimpleThread::~mSimpleThread()
{
	if(target!=NULL && thread !=NULL){
		stop();
	}
}

void mSimpleThread::start()
{
	resume(); //TXyhĂԂ͂
}

void mSimpleThread::stop()
{
	if(target!=NULL && thread!=NULL){
		try{
			thread->SuspendThread();
		}catch(...){
		}
		try{
			delete thread;
		}catch(...){
		}
		thread=NULL;
		target=NULL;
		aliving=false;
		running=false;
	}
}

void mSimpleThread::suspend()
{
	if(target!=NULL && thread !=NULL ){
		running=false;
		thread->SuspendThread();
	}
}

void mSimpleThread::resume()
{
	if(target!=NULL && thread != NULL){
		thread->ResumeThread();
		running=true;
	}
}

bool mSimpleThread::isAlive()
{
	return aliving;
}

bool mSimpleThread::isRunning()
{
	return running;
}


/*---------------------------------*/
mSimpleStopper::mSimpleStopper()
{
	waiting = false;
	b_needStop=false;
}

mSimpleStopper::mSimpleStopper(bool b_needStop)
{
	waiting = false;
	this->b_needStop=b_needStop;
}

void mSimpleStopper::setNeedStop(bool b_needStop)
{
	this->b_needStop=b_needStop;
}

bool mSimpleStopper::needStop()
{
	return b_needStop;
}

void mSimpleStopper::wait()
{
	while(b_needStop){
		waiting = true;
	}
	waiting = false;
}

void mSimpleStopper::lock()
{
	b_needStop=true;
}

void mSimpleStopper::unlock()
{
	b_needStop=false;
}

bool mSimpleStopper::isWaiting()
{
	return waiting;
}
